## arangodb-3.8.5.1.tar.gz

=== CMakeLists.txt ===
# -*- mode: CMAKE; -*-

# ------------------------------------------------------------------------------
# General
# ------------------------------------------------------------------------------

cmake_minimum_required(VERSION 3.9)
message(STATUS "CMake version: ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}.${CMAKE_PATCH_VERSION}")

if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release
      CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE
  )
endif ()

if (NOT (CMAKE_BUILD_TYPE STREQUAL "Debug"
      OR CMAKE_BUILD_TYPE STREQUAL "Release"
      OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo"
      OR CMAKE_BUILD_TYPE STREQUAL "MinSizeRel"
      OR CMAKE_BUILD_TYPE STREQUAL "None"))

  message(FATAL_ERROR "expecting CMAKE_BUILD_TYPE: None Debug Release RelWithDebInfo MinSizeRel, got ${CMAKE_BUILD_TYPE}.")
endif ()

string(TOUPPER ${CMAKE_BUILD_TYPE} CMAKE_BUILD_TYPE_UPPER)

if (APPLE)
  if (NOT CMAKE_OSX_DEPLOYMENT_TARGET OR "${CMAKE_OSX_DEPLOYMENT_TARGET}" STREQUAL "")
    if (NOT DEFINED ENV{MACOSX_DEPLOYMENT_TARGET} OR "ENV{MACOSX_DEPLOYMENT_TARGET}" STREQUAL "")
      message(FATAL_ERROR "environment variable MACOSX_DEPLOYMENT_TARGET is missing")
    else ()
      set(CMAKE_OSX_DEPLOYMENT_TARGET "$ENV{MACOSX_DEPLOYMENT_TARGET}" CACHE STRING "deployment target for MacOSX; adjust to your system")
    endif ()
  else ()
    set($ENV{MACOSX_DEPLOYMENT_TARGET} ${CMAKE_OSX_DEPLOYMENT_TARGET})
  endif ()
endif ()

# where to find CMAKE modules
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})

option(SKIP_PACKAGING "" OFF)

# be verbose about flags used
option(VERBOSE "be verbose about flags used" OFF)

# treat warnings as errors on some platforms
option(USE_FAIL_ON_WARNINGS "treat warnings as errors (MSVC and MacOS only)" ON)

# use strictly required OpenSSL version (from ./VERSIONS file)
option(USE_STRICT_OPENSSL_VERSION "use strictly required OpenSSL version (from ./VERSIONS file)" OFF)

option(USE_MINIMAL_DEBUGINFO "use minimal debug symbols for builds containing debug information" OFF)

# don't use standalone boost asio
# use this when asio is included outside of Boost
# add_definitions("-DARANGODB_STANDALONE_ASIO=0")
# add_definitions("-DFUERTE_STANDALONE_ASIO=0")

# ------------------------------------------------------------------------------
# VERSION information
# ------------------------------------------------------------------------------

# stable release:   MAJOR.MINOR.PATCH
# hot fix:          MAJOR.MINOR.PATCH-FIXNUMBER
# unstable release: MAJOR.MINOR.PATCH-TYPE.NUMBER
# devel:            MAJOR.MINOR.0-devel
#
# These are mapped to the following variables:
#
# ARANGODB_VERSION_MAJOR = MAJOR
# ARANGODB_VERSION_MINOR = MINOR
# ARANGODB_VERSION_PATCH = PATCH
#
# for pre-releases, otherwise empty:
#
# ARANGODB_VERSION_PRELEASE_TYPE   = TYPE
# ARANGODB_VERSION_PRELEASE_NUMBER = NUMBER
#
# This will set the following variables
#
# ARANGODB_DEBIAN_UPSTREAM
# ARANGODB_DEBIAN_REVISION
#
# ARANGODB_RPM_UPSTREAM
# ARANGODB_RPM_REVISION

set(ARANGODB_VERSION_MAJOR "3")
set(ARANGODB_VERSION_MINOR "8")

# when building the nightly ARANGODB_VERSION_PATCH will be set
if (NOT DEFINED ARANGODB_VERSION_PATCH)
  set(ARANGODB_VERSION_PATCH "5")
  set(ARANGODB_VERSION_RELEASE_TYPE "1")
  set(ARANGODB_VERSION_RELEASE_NUMBER "")
else()
  unset (ARANGODB_VERSION_RELEASE_TYPE) # do not remove space
  unset (ARANGODB_VERSION_RELEASE_NUMBER) # do not remove space
endif()

# unset TYPE and NUMBER in case they are empty
if (DEFINED ARANGODB_VERSION_RELEASE_TYPE)
  if (ARANGODB_VERSION_RELEASE_TYPE STREQUAL "")
    unset (ARANGODB_VERSION_RELEASE_TYPE) # do not remove space
    unset (ARANGODB_VERSION_RELEASE_NUMBER) # do not remove space
  endif()
else()
  unset (ARANGODB_VERSION_RELEASE_NUMBER) # do not remove space
endif()

if (DEFINED ARANGODB_VERSION_RELEASE_NUMBER)
  if (ARANGODB_VERSION_RELEASE_NUMBER STREQUAL "")
    unset (ARANGODB_VERSION_RELEASE_NUMBER) # do not remove space
  endif()
endif()

# semantic version
set(ARANGODB_PLAIN_VERSION "${ARANGODB_VERSION_MAJOR}.${ARANGODB_VERSION_MINOR}.${ARANGODB_VERSION_PATCH}")

if (DEFINED ARANGODB_VERSION_RELEASE_TYPE)
  if (DEFINED ARANGODB_VERSION_RELEASE_NUMBER)
    set(ARANGODB_VERSION "${ARANGODB_PLAIN_VERSION}-${ARANGODB_VERSION_RELEASE_TYPE}.${ARANGODB_VERSION_RELEASE_NUMBER}")
  else()
    set(ARANGODB_VERSION "${ARANGODB_PLAIN_VERSION}-${ARANGODB_VERSION_RELEASE_TYPE}")
  endif()
else()
  set(ARANGODB_VERSION "${ARANGODB_PLAIN_VERSION}")
endif()
set(ARANGODB_JS_VERSION "js")

message(STATUS "ARANGODB PLAIN VERSION: ${ARANGODB_PLAIN_VERSION}")
message(STATUS "ARANGODB VERSION: ${ARANGODB_VERSION}")
message(STATUS "ARANGODB JS VERSION: ${ARANGODB_JS_VERSION}")

################################################################################
# DEBIAN, RPM, MacOS version
################################################################################

if (DEFINED ARANGODB_VERSION_RELEASE_TYPE)

  # devel
  if (ARANGODB_VERSION_PATCH STREQUAL "0" AND ARANGODB_VERSION_RELEASE_TYPE STREQUAL "devel")
    set(ARANGODB_DEBIAN_UPSTREAM "${ARANGODB_VERSION_MAJOR}.${ARANGODB_VERSION_MINOR}.0~~${ARANGODB_VERSION_PATCH}")
    set(ARANGODB_DEBIAN_REVISION "1")

    set(ARANGODB_RPM_UPSTREAM "${ARANGODB_VERSION_MAJOR}.${ARANGODB_VERSION_MINOR}.0")
    set(ARANGODB_RPM_REVISION "0.1.devel")

    set(ARANGODB_DARWIN_UPSTREAM "${ARANGODB_PLAIN_VERSION}")
    set(ARANGODB_DARWIN_REVISION "devel")

  # nightly
  elseif (ARANGODB_VERSION_RELEASE_TYPE STREQUAL "nightly")
    set(ARANGODB_DEBIAN_UPSTREAM "${ARANGODB_PLAIN_VERSION}")
    set(ARANGODB_DEBIAN_REVISION "1")

    set(ARANGODB_RPM_UPSTREAM "${ARANGODB_VERSION_MAJOR}.${ARANGODB_VERSION_MINOR}.0")
    set(ARANGODB_RPM_REVISION "0.2.nightly")

    set(ARANGODB_DARWIN_UPSTREAM "${ARANGODB_PLAIN_VERSION}")
    set(ARANGODB_DARWIN_REVISION "nightly")

  # unstable version
  elseif (   ARANGODB_VERSION_RELEASE_TYPE STREQUAL "alpha"
          OR ARANGODB_VERSION_RELEASE_TYPE STREQUAL "beta"
          OR ARANGODB_VERSION_RELEASE_TYPE STREQUAL "milestone"
          OR ARANGODB_VERSION_RELEASE_TYPE STREQUAL "preview"
          OR ARANGODB_VERSION_RELEASE_TYPE STREQUAL "rc")
    if (NOT DEFINED ARANGODB_VERSION_RELEASE_NUMBER)
      message(FATAL_ERROR "ARANGODB_VERSION_RELEASE_NUMBER is missing")
    endif()

    if (ARANGODB_VERSION_RELEASE_TYPE STREQUAL "alpha")
      set(ARANGODB_RPM_REVISION_NUMBER 100)
    elseif (ARANGODB_VERSION_RELEASE_TYPE STREQUAL "beta")
      set(ARANGODB_RPM_REVISION_NUMBER 200)
    elseif (ARANGODB_VERSION_RELEASE_TYPE STREQUAL "milestone")
      set(ARANGODB_RPM_REVISION_NUMBER 300)
    elseif (ARANGODB_VERSION_RELEASE_TYPE STREQUAL "preview")
      set(ARANGODB_RPM_REVISION_NUMBER 400)
    elseif (ARANGODB_VERSION_RELEASE_TYPE STREQUAL "rc")
      set(ARANGODB_RPM_REVISION_NUMBER 500)
    endif()

    MATH(EXPR ARANGODB_RPM_REVISION_NUMBER "${ARANGODB_RPM_REVISION_NUMBER}+${ARANGODB_VERSION_RELEASE_NUMBER}")

    set(ARANGODB_DEBIAN_UPSTREAM "${ARANGODB_PLAIN_VERSION}~${ARANGODB_VERSION_RELEASE_TYPE}.${ARANGODB_VERSION_RELEASE_NUMBER}")
    set(ARANGODB_DEBIAN_REVISION "1")

    set(ARANGODB_RPM_UPSTREAM "${ARANGODB_PLAIN_VERSION}")
    set(ARANGODB_RPM_REVISION "0.${ARANGODB_RPM_REVISION_NUMBER}")

    set(ARANGODB_DARWIN_UPSTREAM "${ARANGODB_PLAIN_VERSION}")
    set(ARANGODB_DARWIN_REVISION "${ARANGODB_VERSION_RELEASE_TYPE}.${ARANGODB_VERSION_RELEASE_NUMBER}")

  # hot-fix
  else()
    if (DEFINED ARANGODB_VERSION_RELEASE_NUMBER)
      message(FATAL_ERROR "ARANGODB_VERSION_RELEASE_NUMBER must be empty for type ${ARANGODB_VERSION_RELEASE_TYPE}")
    endif()

    set(ARANGODB_DEBIAN_UPSTREAM "${ARANGODB_PLAIN_VERSION}.${ARANGODB_VERSION_RELEASE_TYPE}")
    set(ARANGODB_DEBIAN_REVISION "1")

    set(ARANGODB_RPM_UPSTREAM "${ARANGODB_PLAIN_VERSION}")
    set(ARANGODB_RPM_REVISION "1.${ARANGODB_VERSION_RELEASE_TYPE}")

    set(ARANGODB_DARWIN_UPSTREAM "${ARANGODB_PLAIN_VERSION}.${ARANGODB_VERSION_RELEASE_TYPE}")
    set(ARANGODB_DARWIN_REVISION "")
  endif()
else()

  # stable version
  set(ARANGODB_DEBIAN_UPSTREAM "${ARANGODB_PLAIN_VERSION}")
  set(ARANGODB_DEBIAN_REVISION "1")

  set(ARANGODB_RPM_UPSTREAM "${ARANGODB_PLAIN_VERSION}")
  set(ARANGODB_RPM_REVISION "1.0")

  set(ARANGODB_DARWIN_UPSTREAM "${ARANGODB_PLAIN_VERSION}")
  set(ARANGODB_DARWIN_REVISION "")
endif()

message(STATUS "DEBIAN VERSION: ${ARANGODB_DEBIAN_UPSTREAM} / ${ARANGODB_DEBIAN_REVISION}")
message(STATUS "RPM VERSION:    ${ARANGODB_RPM_UPSTREAM} / ${ARANGODB_RPM_REVISION}")
message(STATUS "DARWIN VERSION: ${ARANGODB_DARWIN_UPSTREAM} / ${ARANGODB_DARWIN_REVISION}")


################################################################################
# Windows version
################################################################################

# PATCH needs to be numeric for the windows rc file
set(ARANGODB_WINDOWS_UPSTREAM "${ARANGODB_VERSION}")

if (ARANGODB_VERSION_PATCH GREATER -1)
  set(ARANGODB_WINDOWS_PATCH "${ARANGODB_VERSION_PATCH}")
else()
  set(ARANGODB_WINDOWS_PATCH 1337)
endif()

message(STATUS "WINDOWS VERSION: ${ARANGODB_WINDOWS_UPSTREAM}")

if (MSVC)
  option(USE_CLCACHE_MODE
    "whether we want to use CLCACHE-specific build options"
    OFF
  )
endif ()

################################################################################
# SNAP version
################################################################################

set(ARANGODB_SNAP_REVISION "1")

message(STATUS "SNAP REVISION: ${ARANGODB_SNAP_REVISION}")

# ------------------------------------------------------------------------------
#
# ------------------------------------------------------------------------------

if (WIN32)
  project(arangodb3 LANGUAGES CXX C VERSION ${ARANGODB_VERSION_MAJOR}.${ARANGODB_VERSION_MINOR})
else ()
  project(arangodb3 LANGUAGES CXX C ASM VERSION ${ARANGODB_VERSION_MAJOR}.${ARANGODB_VERSION_MINOR})
endif ()

# required for clang completion in editors - must be set after creating project
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# Static executables:
option(STATIC_EXECUTABLES "produce static executables" OFF)
if (STATIC_EXECUTABLES)
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -static")
  if (WINDOWS)
    set(CMAKE_FIND_LIBRARY_SUFFIXES ".lib")
  else ()
    set(CMAKE_FIND_LIBRARY_SUFFIXES ".a")
  endif ()
endif()

# enable dtrace
option(USE_DTRACE "enable dtrace probes" OFF)
if (USE_DTRACE)
  add_definitions("-DUSE_DTRACE=1")
endif ()

# enable Enterprise Edition features
set(ENTERPRISE_INCLUDE_DIR "enterprise")
option(USE_ENTERPRISE "enable enterprise build" OFF)

if (USE_ENTERPRISE)
  add_definitions("-DUSE_ENTERPRISE=1")
  add_subdirectory(enterprise)
endif ()

# we want the following definitions to be in effect for both rocksdb and arangodb
add_definitions("-DNROCKSDB_THREAD_STATUS")
add_definitions("-DROCKSDB_SUPPORT_THREAD_LOCAL")

# for the packages
set(ARANGODB_PACKAGE_VENDOR  "ArangoDB GmbH")
set(ARANGODB_PACKAGE_CONTACT "info@arangodb.com")
set(ARANGODB_DISPLAY_NAME    "ArangoDB")
set(ARANGODB_URL_INFO_ABOUT  "https://www.arangodb.com")
set(ARANGODB_HELP_LINK       "https://www.arangodb.com/docs/${ARANGODB_VERSION_MAJOR}.${ARANGODB_VERSION_MINOR}/")
set(ARANGODB_CONTACT         "hackers@arangodb.com")
set(ARANGODB_FRIENDLY_STRING "ArangoDB - the native multi-model NoSQL database")

# MSVC
set(ARANGO_BENCH_FRIENDLY_STRING   "arangobench - stress test tool")
set(ARANGO_BACKUP_FRIENDLY_STRING  "arangobackup - hot backup tool")
set(ARANGO_DUMP_FRIENDLY_STRING    "arangodump - data and configuration dumping tool")
set(ARANGO_RESTORE_FRIENDLY_STRING "arangrestore - data and configuration restoration tool")
set(ARANGO_EXPORT_FRIENDLY_STRING  "arangoexport - data exporter")
set(ARANGO_IMPORT_FRIENDLY_STRING  "arangoimport - data importer")
set(ARANGOSH_FRIENDLY_STRING       "arangosh - commandline client")
set(ARANGO_VPACK_FRIENDLY_STRING   "arangovpack - VelocyPack formatter")

=== 3rdParty/CMakeLists.txt ===
# -*- mode: CMAKE; -*-

# ------------------------------------------------------------------------------
# External Projects used by ArangoDB
# ------------------------------------------------------------------------------

include(ExternalProject)

remove_definitions("-DUSE_ENTERPRISE=1")

# Disable IPO for 3rdParty libs. This is because they currently all use old
# cmake versions, missing policy CMP0069.
# Hopefully this can be removed later - just try it out and look for warnings in
# cmake's output. Also, you can use the compile_commands.json optionally emitted
# by cmake (see CMAKE_EXPORT_COMPILE_COMMANDS) and jq to get a list of files we
# do not compile with IPO (assuming gcc or clang) with this command:
#   < compile_commands.json jq '.[] | select(.command | test("-flto") | not) | .file' -r
if (${IPO_ENABLED})
  message ("Disabling IPO for 3rdParty libraries")
  set(CMAKE_INTERPROCEDURAL_OPTIMIZATION False)
endif ()

################################################################################
## ZLIB
################################################################################

set(SKIP_INSTALL_ALL ON)
add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/zlib/zlib-1.2.11)

################################################################################
## SNAPPY
################################################################################

set(SNAPPY_VERSION "1.1.8")
set(SNAPPY_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/snappy/snappy-${SNAPPY_VERSION}")
set(SNAPPY_SOURCE_DIR "${SNAPPY_SOURCE_DIR}" PARENT_SCOPE)
set(SNAPPY_BUILD_DIR "${CMAKE_CURRENT_BINARY_DIR}/snappy/snappy-${SNAPPY_VERSION}")
set(SNAPPY_BUILD_DIR "${SNAPPY_BUILD_DIR}" PARENT_SCOPE)
set(SNAPPY_LIB "snappy")
set(SNAPPY_LIB "${SNAPPY_LIB}" PARENT_SCOPE)
set(SNAPPY_BUILD_TESTS OFF CACHE BOOL "disable Snappy tests")
set(SNAPPY_INSTALL OFF CACHE BOOL "disable Snappy installation")
add_subdirectory(${SNAPPY_SOURCE_DIR} EXCLUDE_FROM_ALL)

################################################################################
## LIBUNWIND
################################################################################

if (USE_LIBUNWIND)
  add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/libunwind)
  include_directories(SYSTEM "${LIBUNWIND_HOME}/include")
  set(LIBUNWIND_HOME "${LIBUNWIND_HOME}" PARENT_SCOPE)
  set(LIBUNWIND_LIB "${LIBUNWIND_LIB}" PARENT_SCOPE)
endif ()

################################################################################
## JEMALLOC
################################################################################

if (USE_JEMALLOC)
  add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/jemalloc)
  include_directories(SYSTEM "${JEMALLOC_HOME}/include")
  link_directories("${JEMALLOC_HOME}/lib")
  set(JEMALLOC_HOME "${JEMALLOC_HOME}" PARENT_SCOPE)
  set(SYS_LIBS ${SYS_LIBS} jemalloc PARENT_SCOPE)
  set(JEMALLOC_LIB "${JEMALLOC_LIB}" PARENT_SCOPE)
endif ()

################################################################################
## V8 and ICU
################################################################################

option(USE_PRECOMPILED_V8 "use a precompiled V8" OFF)

set(V8_VERSION
  "7.9.317"
  CACHE INTERNAL
  "${PROJECT_NAME}: Version"
  FORCE
  )
set(V8_SUB_DIR "v${V8_VERSION}")
set(V8_VERSION ${V8_VERSION} PARENT_SCOPE)
add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/V8)
set(ICU_DT "${ICU_DT}" PARENT_SCOPE)
set(ICU_DT_DEST "${ICU_DT_DEST}" PARENT_SCOPE)
set(ICU_LIBRARY_DIR "${ICU_LIBRARY_DIR}" PARENT_SCOPE)
set(ICU_ROOT "${CMAKE_CURRENT_SOURCE_DIR}/V8/${V8_SUB_DIR}/third_party/icu/")

################################################################################
## Google S2
################################################################################

add_subdirectory(s2geometry)
set(ARANGO_S2GEOMETRY_VERSION "${ARANGO_S2GEOMETRY_VERSION}" PARENT_SCOPE)

################################################################################
## Googletest
################################################################################

#add_subdirectory(googletest)
#set(ARANGO_GOOGLETEST_VERSION "${ARANGO_GOOGLETEST_VERSION}" PARENT_SCOPE)

################################################################################
## BOOST
################################################################################

add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/boost)
set(BOOST_VERSION ${BOOST_VERSION} PARENT_SCOPE)

################################################################################
## Velocypack
################################################################################

set(BuildVelocyPackExamples OFF CACHE BOOL "Build VelocyPack Examples" FORCE)
set(BuildTools OFF CACHE BOOL "Build VelocyPack Tools" FORCE)

add_subdirectory(velocypack EXCLUDE_FROM_ALL)

################################################################################
## IResearch
################################################################################

add_library(boost-static IMPORTED STATIC)
set_target_properties(boost-static PROPERTIES
  INTERFACE_INCLUDE_DIRECTORIES "${CMAKE_CURRENT_SOURCE_DIR}/boost/${BOOST_VERSION}"
  IMPORTED_LOCATION "boost_locale;boost_system;boost_thread"
)

# explicitly set since suppressing Boost search
set(Boost_INCLUDE_DIRS "${CMAKE_CURRENT_SOURCE_DIR}/boost/${BOOST_VERSION}")

set(ICU_FOUND TRUE) # ICU built from source in 3rdParty directory

if(NOT PERL_FOUND)
  set(PERL_FOUND TRUE) # suppress error for Perl not-found

  # MSVC will execute ADD_CUSTOM_COMMAND even though OUTPUT is already present
  if(MSVC)
    set(PERL_EXECUTABLE echo)
  endif()
endif()

set(USE_IPO ${IPO_ENABLED})
set(ICU_STATIC_LIBS ${ICU_LIBS})
set(LZ4_ROOT "${CMAKE_CURRENT_SOURCE_DIR}/lz4")
set(LZ4_INCLUDE_DIR "${LZ4_ROOT}/lib" PARENT_SCOPE)
set(SNOWBALL_ROOT "${CMAKE_CURRENT_SOURCE_DIR}/snowball")
set(UNWIND_ROOT "invalid")
set(BFD_ROOT "invalid")
find_package(IResearch REQUIRED) # set IRESEARCH_BUILD_DIR

set(CMAKE_MACOSX_RPATH ON) # suppress cmake warning (use same value as cmake default)
set(CMAKE_MODULE_PATH_ORIGINAL ${CMAKE_MODULE_PATH}) # remember CMAKE_MODULE_PATH
list(APPEND CMAKE_MODULE_PATH
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake" # cmake overrides (must be first)
  "${IRESEARCH_ROOT}/cmake" # to find iResearch dependencies
)

# copy pre-built files over to the build directory
# this is required to avoid triggering file generation via bison and perl during the build procedure
file(GLOB_RECURSE IRESEARCH_PREBUILT RELATIVE "${IRESEARCH_ROOT}.build" FOLLOW_SYMLINKS "${IRESEARCH_ROOT}.build/*")
foreach(ELEMENT ${IRESEARCH_PREBUILT})
  configure_file("${IRESEARCH_ROOT}.build/${ELEMENT}" "${IRESEARCH_BUILD_DIR}/${ELEMENT}" COPYONLY)
endforeach()

add_subdirectory("${IRESEARCH_ROOT}" "${IRESEARCH_BUILD_DIR}" EXCLUDE_FROM_ALL) # do not build unused targets
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH_ORIGINAL}) # restore CMAKE_MODULE_PATH
unset(BUILD_SHARED_LIBS) # otherwise ZLib (below) does not build on win32
unset(BUILD_SHARED_LIBS CACHE) # otherwise ZLib (below) does not build on win32

################################################################################
## ROCKSDB
################################################################################

add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/rocksdb)
include_directories(${ROCKSDB_INCLUDE_DIR})
set(ARANGO_ROCKSDB_VERSION "${ARANGO_ROCKSDB_VERSION}" PARENT_SCOPE)

################################################################################
## NGHTTP2
################################################################################

add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/nghttp2/)

################################################################################
## IMMER
################################################################################

set(IMMER_VERSION "0.6.2")
add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/immer/v${IMMER_VERSION} EXCLUDE_FROM_ALL)

################################################################################
## LINK_DIRECTORIES
################################################################################

set(LINK_DIRECTORIES "${LINK_DIRECTORIES}" PARENT_SCOPE)

set(STARTER_SOURCE "${PROJECT_SOURCE_DIR}/3rdParty/arangodb-starter/")
set(STARTER_BUILD "${CMAKE_CURRENT_BINARY_DIR}/arangodb-starter/")
set(STARTER_BINARY "${STARTER_BUILD}/arangodb${CMAKE_EXECUTABLE_SUFFIX}")
if (EXISTS ${STARTER_SOURCE})
  find_program(GO_COMMAND "go")
  if (GO_COMMAND)
    MESSAGE("-- building arangodb starter.")
    ExternalProject_Add(arangodb_starter_build
      SOURCE_DIR
      ${STARTER_SOURCE}
      CONFIGURE_COMMAND
      ""
      BINARY_DIR
      ${STARTER_BUILD}
      BUILD_COMMAND
      $(MAKE) -f "${STARTER_SOURCE}Makefile" "NODOCKER=1" "BUILDDIR=${STARTER_BUILD}" "SCRIPTDIR=${STARTER_SOURCE}" local
      LOG_INSTALL 1
      INSTALL_DIR
      ${CMAKE_INSTALL_BINDIR}
      INSTALL_COMMAND
      ${CMAKE_COMMAND} -E copy ${STARTER_BINARY} ${CMAKE_INSTALL_BINDIR}
      )
    list(APPEND THIRDPARTY_BIN ${STARTER_BINARY})
    set(THIRDPARTY_BIN ${THIRDPARTY_BIN} PARENT_SCOPE)
  else()
    MESSAGE(WARNING "arangodb starter source present, but no go command to build it found.")
  endif()
endif()

add_library(fuerte STATIC
    ${CMAKE_CURRENT_SOURCE_DIR}/fuerte/src/connection.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/fuerte/src/ConnectionBuilder.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/fuerte/src/helper.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/fuerte/src/http.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/fuerte/src/H1Connection.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/fuerte/src/H2Connection.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/fuerte/src/jwt.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/fuerte/src/loop.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/fuerte/src/message.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/fuerte/src/requests.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/fuerte/src/types.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/fuerte/src/vst.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/fuerte/src/VstConnection.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/fuerte/src/connection.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/fuerte/src/http_parser/http_parser.c
  )

target_link_libraries(fuerte nghttp2)

include(CheckTypeSize)
check_type_size("ssize_t" SIZEOF_SSIZE_T)
if(SIZEOF_SSIZE_T STREQUAL "")
  # ssize_t is a signed type in POSIX storing at least -1.
  # Set it to "int" to match the behavior of AC_TYPE_SSIZE_T (autotools).
  target_compile_definitions(fuerte PRIVATE ssize_t=int)
endif()

target_include_directories(fuerte SYSTEM PRIVATE
  "${Boost_INCLUDE_DIRS}/"
  "${CMAKE_CURRENT_SOURCE_DIR}/velocypack/include"
  "${CMAKE_CURRENT_SOURCE_DIR}/fuerte/include")

set(V8_INTERNAL_INCLUDE_DIR ${V8_INTERNAL_INCLUDE_DIR} PARENT_SCOPE)


set(TAOCPP_JSON_BUILD_TESTS    OFF CACHE BOOL "Build taocpp::json test programs"    FORCE)
set(TAOCPP_JSON_BUILD_EXAMPLES OFF CACHE BOOL "Build taocpp::json example programs" FORCE)
add_subdirectory(taocpp-json EXCLUDE_FROM_ALL)
add_subdirectory(json-schema-validation EXCLUDE_FROM_ALL)


LIST(APPEND TZ_DATA_FILES
  "${CMAKE_CURRENT_SOURCE_DIR}/tzdata/africa"
  "${CMAKE_CURRENT_SOURCE_DIR}/tzdata/antarctica"
  "${CMAKE_CURRENT_SOURCE_DIR}/tzdata/asia"
  "${CMAKE_CURRENT_SOURCE_DIR}/tzdata/australasia"
  "${CMAKE_CURRENT_SOURCE_DIR}/tzdata/backward"
  "${CMAKE_CURRENT_SOURCE_DIR}/tzdata/backzone"
  "${CMAKE_CURRENT_SOURCE_DIR}/tzdata/calendars"
  "${CMAKE_CURRENT_SOURCE_DIR}/tzdata/etcetera"
  "${CMAKE_CURRENT_SOURCE_DIR}/tzdata/europe"
  "${CMAKE_CURRENT_SOURCE_DIR}/tzdata/NEWS"
  "${CMAKE_CURRENT_SOURCE_DIR}/tzdata/northamerica"
  "${CMAKE_CURRENT_SOURCE_DIR}/tzdata/southamerica"
  "${CMAKE_CURRENT_SOURCE_DIR}/tzdata/version"
  "${CMAKE_CURRENT_SOURCE_DIR}/tzdata/windowsZones.xml")

set(TZ_DATA_FILES ${TZ_DATA_FILES} PARENT_SCOPE)



if (MSVC)
  add_custom_command(
    TARGET fuerte POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_BINARY_DIR}/bin/$<CONFIG>/tzdata)

  add_custom_command(
    TARGET fuerte POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_BINARY_DIR}/tests/$<CONFIG>/tzdata)

  add_custom_command(

=== Documentation/CMakeLists.txt ===
# -*- mode: CMAKE; -*-

# swagger
add_custom_target(swagger
  COMMAND ${PROJECT_SOURCE_DIR}/utils/generateSwagger.sh
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR})

# swagger
add_custom_target(examples
  COMMAND ${PROJECT_SOURCE_DIR}/utils/generateExamples.sh
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR})

# manual pages
set(MAN_NAMES
  man1/arangobench.1
  man1/arangodump.1
  man1/arangoimport.1
  man1/arangorestore.1
  man1/arangoexport.1
  man1/arangosh.1
  man8/rcarangod.8
  man8/arangod.8
  man8/foxx-manager.8
  )

set(MAN_FILES "") #empty list


foreach (m IN LISTS MAN_NAMES)
    set(msrc ${CMAKE_SOURCE_DIR}/Documentation/${m})
    set(mdst ${CMAKE_CURRENT_BINARY_DIR}/man/${m})

  add_custom_command(
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    OUTPUT  ${mdst}
    COMMAND ${CMAKE_SOURCE_DIR}/utils/manPages.sh ${msrc} ${mdst} ${ARANGODB_VERSION}
    DEPENDS ${msrc}
    COMMENT "Building manpage ${mdst}"
    VERBATIM
    )
  list(APPEND MAN_FILES ${mdst})
endforeach ()
set(ARANGO_MAN_DIR "${CMAKE_CURRENT_BINARY_DIR}/man" PARENT_SCOPE)

# avoid deleting README on "make clean"...
set_directory_properties(PROPERTIES CLEAN_NO_CUSTOM "On")
# ...but still delete man files
set_property(DIRECTORY APPEND PROPERTY ADDITIONAL_MAKE_CLEAN_FILES ${MAN_FILES})

add_custom_command(
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  OUTPUT  ${CMAKE_SOURCE_DIR}/README
  COMMAND ${CMAKE_SOURCE_DIR}/utils/generateREADME.sh ${CMAKE_SOURCE_DIR}/README.md ${CMAKE_SOURCE_DIR}/README
  DEPENDS ${CMAKE_SOURCE_DIR}/README.md
  COMMENT "Building README"
  VERBATIM
  )

list(APPEND MAN_FILES ${CMAKE_SOURCE_DIR}/README)

add_custom_target(man DEPENDS ${MAN_FILES})

add_custom_target(clean_man_autogenerated
  COMMAND rm -f ${CMAKE_SOURCE_DIR}/README
  COMMAND rm -f ${MAN_FILES})

list(APPEND CLEAN_AUTOGENERATED_FILES clean_man_autogenerated)
set(CLEAN_AUTOGENERATED_FILES ${CLEAN_AUTOGENERATED_FILES} PARENT_SCOPE)

=== arangod/CMakeLists.txt ===
#- * - mode : CMAKE; - * -

include_directories(.)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/bin/")

################################################################################
## BISON/FLEX
################################################################################

#note that we check - in the generated FLEX / BISON files, therefore they are
#generate inside the source tree

if (USE_MAINTAINER_MODE AND NOT MSVC)
  set_directory_properties(PROPERTIES CLEAN_NO_CUSTOM "On")

  add_custom_command(
    OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/Aql/tokens.cpp
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMAND ${FLEX_EXECUTABLE} -L -oAql/tokens.cpp Aql/tokens.ll
    MAIN_DEPENDENCY ${CMAKE_CURRENT_SOURCE_DIR}/Aql/tokens.ll
    VERBATIM
  )

  add_custom_command(
    OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/Aql/grammar.cpp
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMAND ${CMAKE_SOURCE_DIR}/utils/bison-c.sh
      ${BISON_EXECUTABLE} Aql/grammar.cpp Aql/grammar.y
    MAIN_DEPENDENCY ${CMAKE_CURRENT_SOURCE_DIR}/Aql/grammar.y
    VERBATIM
  )

  add_custom_target(clean_aql_autogenerated
    COMMAND rm -f Aql/tokens.cpp Aql/tokens.h Aql/grammar.cpp Aql/grammar.h
  )

  list(APPEND CLEAN_AUTOGENERATED_FILES clean_aql_autogenerated)
  set(CLEAN_AUTOGENERATED_FILES ${CLEAN_AUTOGENERATED_FILES} PARENT_SCOPE)
endif ()

if (CMAKE_COMPILER_IS_GNUCC)
  set_source_files_properties(Aql/tokens.cpp PROPERTIES COMPILE_FLAGS -Wno-sign-compare)
endif ()

################################################################################
## IResearch
################################################################################

find_package(IResearch REQUIRED)

add_library(arango_iresearch
  STATIC
  IResearch/ApplicationServerHelper.h IResearch/ApplicationServerHelper.cpp
  IResearch/AqlHelper.cpp IResearch/AqlHelper.h
  IResearch/Containers.cpp IResearch/Containers.h
  IResearch/ExpressionFilter.cpp IResearch/ExpressionFilter.h
  IResearch/Geo.cpp IResearch/Geo.h
  IResearch/GeoAnalyzer.cpp IResearch/GeoAnalyzer.h
  IResearch/GeoFilter.cpp IResearch/GeoFilter.h
  IResearch/IResearchAnalyzerFeature.cpp IResearch/IResearchAnalyzerFeature.h
  IResearch/IResearchAqlAnalyzer.cpp IResearch/IResearchAqlAnalyzer.h
  IResearch/IResearchCommon.cpp IResearch/IResearchCommon.h
  IResearch/IResearchCompression.cpp IResearch/IResearchCompression.h
  IResearch/IResearchDocument.cpp IResearch/IResearchDocument.h
  IResearch/IResearchExpressionContext.cpp IResearch/IResearchExpressionContext.h
  IResearch/IResearchFeature.cpp IResearch/IResearchFeature.h
  IResearch/IResearchFilterFactory.cpp IResearch/IResearchFilterFactory.h
  IResearch/IResearchIdentityAnalyzer.cpp IResearch/IResearchIdentityAnalyzer.h
  IResearch/IResearchKludge.cpp IResearch/IResearchKludge.h
  IResearch/IResearchLink.cpp IResearch/IResearchLink.h
  IResearch/IResearchLinkCoordinator.cpp IResearch/IResearchLinkCoordinator.h
  IResearch/IResearchLinkHelper.cpp IResearch/IResearchLinkHelper.h
  IResearch/IResearchLinkMeta.cpp IResearch/IResearchLinkMeta.h
  IResearch/IResearchOrderFactory.cpp IResearch/IResearchOrderFactory.h
  IResearch/IResearchPDP.cpp IResearch/IResearchPDP.h
  IResearch/IResearchPrimaryKeyFilter.cpp IResearch/IResearchPrimaryKeyFilter.h
  IResearch/IResearchRocksDBLink.cpp IResearch/IResearchRocksDBLink.h
  IResearch/IResearchRocksDBRecoveryHelper.cpp
  IResearch/IResearchRocksDBRecoveryHelper.h
  IResearch/IResearchVPackComparer.cpp IResearch/IResearchVPackComparer.h
  IResearch/IResearchView.cpp IResearch/IResearchView.h
  IResearch/IResearchViewCoordinator.cpp IResearch/IResearchViewCoordinator.h
  IResearch/IResearchViewMeta.cpp IResearch/IResearchViewMeta.h
  IResearch/IResearchViewSort.cpp IResearch/IResearchViewSort.h
  IResearch/IResearchViewStoredValues.cpp IResearch/IResearchViewStoredValues.h
  IResearch/VelocyPackHelper.cpp IResearch/VelocyPackHelper.h
  RestHandler/RestAnalyzerHandler.cpp RestHandler/RestAnalyzerHandler.h
)

target_compile_definitions(arango_iresearch
  PUBLIC "$<$<CONFIG:Debug>:IRESEARCH_DEBUG=1>"
)

set(IRESEARCH_TARGET_DEPENDENCY iresearch-static) # use static to match ArangoDB


get_target_property(IRESEARCH_INCLUDE
  ${IRESEARCH_TARGET_DEPENDENCY} INCLUDE_DIRECTORIES)

target_include_directories(arango_iresearch
  PUBLIC ${IRESEARCH_INCLUDE}
)

if (USE_ENTERPRISE)
  target_include_directories(arango_iresearch
    PUBLIC "${PROJECT_SOURCE_DIR}/${ENTERPRISE_INCLUDE_DIR}"
  )
endif()

target_link_libraries(arango_iresearch
  ${IRESEARCH_TARGET_DEPENDENCY}
  s2 # needed for some includes
  boost_locale # required by iResearch
)

add_dependencies(arango_iresearch
  ${IRESEARCH_TARGET_DEPENDENCY}
  v8_build # for ICU required by iResearch
)

################################################################################
# llhttp
################################################################################


SET(LLHTTP_SOURCES
  ${PROJECT_SOURCE_DIR}/3rdParty/llhttp/src/api.c
  ${PROJECT_SOURCE_DIR}/3rdParty/llhttp/src/http.c
  ${PROJECT_SOURCE_DIR}/3rdParty/llhttp/src/llhttp.c
)


################################################################################
## arangod
################################################################################

if (MSVC AND NOT(SKIP_PACKAGING))
  generate_product_version(ProductVersionFiles
    NAME arangod
    FILE_DESCRIPTION ${ARANGODB_FRIENDLY_STRING}
    ICON ${ARANGO_ICON}
    VERSION_MAJOR ${CPACK_PACKAGE_VERSION_MAJOR}
    VERSION_MINOR ${CPACK_PACKAGE_VERSION_MINOR}
    VERSION_PATCH ${CPACK_PACKAGE_VERSION_PATCH}
    VERSION_REVISION ${BUILD_ID}
  )
endif ()

if (USE_ENTERPRISE)
  set(ENTERPRISE_FILES "")
else ()
  set(ENTERPRISE_FILES
    Utils/Events.cpp
  )
endif ()

set(LIB_ARANGO_GRAPH_SOURCES
  Aql/PruneExpressionEvaluator.cpp
  Cluster/CallbackGuard.cpp
  Cluster/ClusterEdgeCursor.cpp
  Cluster/ClusterTraverser.cpp
  Cluster/ServerDefaults.cpp
  Cluster/TraverserEngine.cpp
  Graph/AttributeWeightShortestPathFinder.cpp
  Graph/BaseOptions.cpp
  Graph/BreadthFirstEnumerator.cpp
  Graph/ClusterGraphDatalake.cpp
  Graph/ClusterTraverserCache.cpp
  Graph/ConstantWeightShortestPathFinder.cpp
  Graph/Graph.cpp
  Graph/GraphManager.cpp
  Graph/GraphOperations.cpp
  Graph/KShortestPathsFinder.cpp
  Graph/NeighborsEnumerator.cpp
  Graph/PathEnumerator.cpp
  Graph/ShortestPathFinder.cpp
  Graph/ShortestPathOptions.cpp
  Graph/ShortestPathResult.cpp
  Graph/ShortestPathType.cpp
  Graph/SingleServerEdgeCursor.cpp
  Graph/SingleServerTraverser.cpp
  Graph/Traverser.cpp
  Graph/TraverserCache.cpp
  Graph/TraverserCacheFactory.cpp
  Graph/TraverserDocumentCache.cpp
  Graph/TraverserOptions.cpp
  Graph/WeightedEnumerator.cpp
  Graph/Cursors/RefactoredSingleServerEdgeCursor.cpp
  Graph/Cache/RefactoredTraverserCache.cpp
  Graph/Cache/RefactoredClusterTraverserCache.cpp
  Graph/Enumerators/TwoSidedEnumerator.cpp
  Graph/Helpers/TraceEntry.cpp
  Graph/Queues/QueueTracer.cpp
  Graph/PathManagement/PathResult.cpp
  Graph/PathManagement/PathStore.cpp
  Graph/PathManagement/PathStoreTracer.cpp
  Graph/PathManagement/PathValidator.cpp
  Graph/Options/TwoSidedEnumeratorOptions.cpp
  Graph/Providers/ClusterProvider.cpp
  Graph/Providers/SingleServerProvider.cpp
  Graph/Providers/BaseProviderOptions.cpp
  Graph/Providers/ProviderTracer.cpp
  Graph/Types/UniquenessLevel.cpp
  Graph/Types/ValidationResult.cpp
  InternalRestHandler/InternalRestTraverserHandler.cpp
  RestHandler/RestGraphHandler.cpp
)

set(LIB_ARANGO_PREGEL_AIR_SOURCES
  Pregel/Algos/AIR/AIR.cpp
  Pregel/Algos/AIR/AbstractAccumulator.cpp
  Pregel/Algos/AIR/AccumulatorOptions.cpp
  Pregel/Algos/AIR/Accumulators.cpp
  Pregel/Algos/AIR/EdgeData.cpp
  Pregel/Algos/AIR/GraphFormat.cpp
  Pregel/Algos/AIR/MasterContext.cpp
  Pregel/Algos/AIR/MessageData.cpp
  Pregel/Algos/AIR/MessageFormat.cpp
  Pregel/Algos/AIR/VertexComputation.cpp
  Pregel/Algos/AIR/VertexData.cpp
  Pregel/Algos/AIR/WorkerContext.cpp
)

set(LIB_ARANGO_PREGEL_SOURCES
  Pregel/AggregatorHandler.cpp
  Pregel/AlgoRegistry.cpp
  Pregel/Algos/AsyncSCC.cpp
  Pregel/Algos/ConnectedComponents.cpp
  Pregel/Algos/DMID/DMID.cpp
  Pregel/Algos/EffectiveCloseness/EffectiveCloseness.cpp
  Pregel/Algos/EffectiveCloseness/HLLCounter.cpp
  Pregel/Algos/HITS.cpp
  Pregel/Algos/LabelPropagation.cpp
  Pregel/Algos/LineRank.cpp
  Pregel/Algos/PageRank.cpp
  Pregel/Algos/RecoveringPageRank.cpp
  Pregel/Algos/SCC.cpp
  Pregel/Algos/SLPA.cpp
  Pregel/Algos/SSSP.cpp
  Pregel/Algos/ShortestPath.cpp
  Pregel/Algos/WCC.cpp
  Pregel/Conductor.cpp
  Pregel/GraphStore.cpp
  Pregel/IncomingCache.cpp
  Pregel/IndexHelpers.cpp
  Pregel/OutgoingCache.cpp
  Pregel/PregelFeature.cpp
  Pregel/Recovery.cpp
  Pregel/Reports.cpp
  Pregel/Reports.h
  Pregel/Utils.cpp
  Pregel/Worker-templates-algorithms.cpp
  Pregel/Worker-templates-native-types.cpp
  Pregel/Worker.cpp
  Pregel/WorkerConfig.cpp
  RestHandler/RestControlPregelHandler.cpp
  RestHandler/RestPregelHandler.cpp
)

set(LIB_ARANGO_AQL_SOURCES
  Aql/Aggregator.cpp
  Aql/AllRowsFetcher.cpp
  Aql/AqlCall.cpp
  Aql/AqlCallList.cpp
  Aql/AqlCallSet.cpp
  Aql/AqlCallStack.cpp
  Aql/AqlExecuteResult.cpp
  Aql/AqlFunctionFeature.cpp
  Aql/AqlFunctionsInternalCache.cpp
  Aql/AqlItemBlock.cpp
  Aql/AqlItemBlockInputMatrix.cpp
  Aql/AqlItemBlockInputRange.cpp
  Aql/AqlItemBlockManager.cpp
  Aql/AqlItemBlockUtils.cpp
  Aql/AqlItemMatrix.cpp
  Aql/AqlTransaction.cpp
  Aql/AqlValue.cpp
  Aql/AqlValueGroup.cpp
  Aql/AqlValueMaterializer.cpp
  Aql/Arithmetic.cpp
  Aql/Ast.cpp
  Aql/AstHelper.cpp
  Aql/AstNode.cpp
  Aql/AstResources.cpp
  Aql/AsyncExecutor.cpp
  Aql/AttributeAccessor.cpp
  Aql/AttributeNamePath.cpp
  Aql/BindParameters.cpp
  Aql/BlocksWithClients.cpp
  Aql/CalculationExecutor.cpp
  Aql/CalculationNodeVarFinder.cpp
  Aql/ClusterNodes.cpp
  Aql/CollectNode.cpp
  Aql/CollectOptions.cpp
  Aql/Collection.cpp
  Aql/CollectionAccess.cpp
  Aql/CollectionAccessingNode.cpp
  Aql/Collections.cpp
  Aql/Condition.cpp
  Aql/ConditionFinder.cpp
  Aql/ConstFetcher.cpp
  Aql/ConstrainedSortExecutor.cpp
  Aql/CostEstimate.cpp
  Aql/CountCollectExecutor.cpp
  Aql/DependencyProxy.cpp
  Aql/DistinctCollectExecutor.cpp
  Aql/DistributeClientBlock.cpp
  Aql/DistributeConsumerNode.cpp
  Aql/DistributeExecutor.cpp
  Aql/DocumentExpressionContext.cpp
  Aql/DocumentIndexExpressionContext.cpp
  Aql/DocumentProducingHelper.cpp
  Aql/DocumentProducingNode.cpp
  Aql/ClusterQuery.cpp
  Aql/EngineInfoContainerCoordinator.cpp
  Aql/EngineInfoContainerDBServerServerBased.cpp
  Aql/EnumerateCollectionExecutor.cpp
  Aql/EnumerateListExecutor.cpp
  Aql/ExecutionBlock.cpp
  Aql/ExecutionBlockImpl.cpp
  Aql/ExecutionEngine.cpp
  Aql/ExecutionNode.cpp
  Aql/ExecutionNodeId.cpp
  Aql/ExecutionPlan.cpp
  Aql/ExecutionState.cpp
  Aql/ExecutionStats.cpp
  Aql/ExecutorExpressionContext.cpp
  Aql/Expression.cpp
  Aql/FilterExecutor.cpp
  Aql/FixedVarExpressionContext.cpp
  Aql/Function.cpp
  Aql/Functions.cpp
  Aql/GraphNode.cpp
  Aql/Graphs.cpp
  Aql/HashedCollectExecutor.cpp
  Aql/IResearchViewExecutor.cpp
  Aql/IResearchViewNode.cpp
  Aql/IResearchViewOptimizerRules.cpp
  Aql/IdExecutor.cpp
  Aql/InAndOutRowExpressionContext.cpp
  Aql/IndexExecutor.cpp
  Aql/IndexHint.cpp
  Aql/IndexNode.cpp
  Aql/IndexNodeOptimizerRules.cpp
  Aql/InputAqlItemRow.cpp
  Aql/InsertModifier.cpp
  Aql/KShortestPathsExecutor.cpp
  Aql/KShortestPathsNode.cpp
  Aql/LateMaterializedOptimizerRulesCommon.cpp
  Aql/LimitExecutor.cpp
  Aql/LimitStats.cpp
  Aql/MaterializeExecutor.cpp
  Aql/ModificationExecutor.cpp
  Aql/ModificationExecutorHelpers.cpp
  Aql/ModificationExecutorInfos.cpp
  Aql/ModificationNodes.cpp
  Aql/ModificationOptions.cpp
  Aql/MultiAqlItemBlockInputRange.cpp
  Aql/MultiDependencySingleRowFetcher.cpp
  Aql/MutexExecutor.cpp
  Aql/MutexNode.cpp
  Aql/NodeFinder.cpp
  Aql/NonConstExpression.cpp
  Aql/NonConstExpressionContainer.cpp
  Aql/NoResultsExecutor.cpp
  Aql/Optimizer.cpp
  Aql/OptimizerRules.cpp

=== arangosh/CMakeLists.txt ===
# -*- mode: CMAKE; -*-

include_directories(.)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/bin/")

################################################################################
## shell common
################################################################################

set(LIB_ARANGO_SHELL_SOURCES
  FeaturePhases/BasicFeaturePhaseClient.cpp
  FeaturePhases/V8ShellFeaturePhase.cpp
  Shell/ClientFeature.cpp
  Shell/ConsoleFeature.cpp  
  Utils/ClientManager.cpp
  Utils/ManagedDirectory.cpp
  V8Client/ArangoClientHelper.cpp
)

add_library(arango_shell STATIC
  ${LIB_ARANGO_SHELL_SOURCES}
)

target_link_libraries(arango_shell
  arango
  ${MSVC_LIBS}
  ${SYSTEM_LIBRARIES}
  boost_system
  boost_boost
)

################################################################################
## arangobench
################################################################################

if (MSVC AND NOT(SKIP_PACKAGING))
  generate_product_version(ProductVersionFiles_arangobench
    NAME arangobench
    FILE_DESCRIPTION ${ARANGOBENCH_FRIENDLY_STRING}
    ICON ${ARANGO_ICON}
    VERSION_MAJOR ${CPACK_PACKAGE_VERSION_MAJOR}
    VERSION_MINOR ${CPACK_PACKAGE_VERSION_MINOR}
    VERSION_PATCH ${CPACK_PACKAGE_VERSION_PATCH}
    VERSION_REVISION ${BUILD_ID}
  )
endif ()

add_executable(${BIN_ARANGOBENCH}
  ${ProductVersionFiles_arangobench}
  Benchmark/arangobench.cpp
  Benchmark/BenchFeature.cpp
  Benchmark/BenchmarkOperation.cpp
  Benchmark/testcases/helpers.cpp
)
target_include_directories(${BIN_ARANGOBENCH} PRIVATE ${PROJECT_SOURCE_DIR}/arangosh)

target_link_libraries(${BIN_ARANGOBENCH}
  arango
  ${MSVC_LIBS}
  ${SYSTEM_LIBRARIES}
  boost_system
  boost_boost
  arango_shell
)

install(
  TARGETS ${BIN_ARANGOBENCH}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

install_config(arangobench)

if (NOT USE_PRECOMPILED_V8)
  add_dependencies(arangobench zlibstatic v8_build) # v8_build includes ICU build
else ()
  add_dependencies(arangobench zlibstatic)
endif ()

if (USE_JEMALLOC)
  add_dependencies(arangobench jemalloc_build)
endif ()

if (USE_FAIL_ON_WARNINGS)
 if (MSVC)
   target_compile_options(arangobench PRIVATE /WX /D_WINSOCK_DEPRECATED_NO_WARNINGS)
 else ()
   target_compile_options(arangobench PRIVATE -Werror -Wno-error=deprecated-declarations)
 endif ()
endif ()

################################################################################
## arangobackup
################################################################################

if (USE_ENTERPRISE)

if (MSVC AND NOT(SKIP_PACKAGING))
  generate_product_version(ProductVersionFiles_arangobackup
    NAME arangobackup
    FILE_DESCRIPTION ${ARANGO_BACKUP_FRIENDLY_STRING}
    ICON ${ARANGO_ICON}
    VERSION_MAJOR ${CPACK_PACKAGE_VERSION_MAJOR}
    VERSION_MINOR ${CPACK_PACKAGE_VERSION_MINOR}
    VERSION_PATCH ${CPACK_PACKAGE_VERSION_PATCH}
    VERSION_REVISION ${BUILD_ID}
  )
endif ()

add_executable(${BIN_ARANGOBACKUP}
  ${ProductVersionFiles_arangobackup}
  Backup/BackupFeature.cpp
  Backup/arangobackup.cpp
  ${ADDITIONAL_BIN_ARANGOBACKUP_SOURCES}
)
target_include_directories(${BIN_ARANGOBACKUP} PRIVATE ${PROJECT_SOURCE_DIR}/arangosh)

target_link_libraries(${BIN_ARANGOBACKUP}
  arango
  ${MSVC_LIBS}
  ${SYSTEM_LIBRARIES}
  boost_system
  boost_boost
  arango_shell
  fuerte
)

install(
  TARGETS ${BIN_ARANGOBACKUP}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

install_config(arangobackup)

if (NOT USE_PRECOMPILED_V8)
  add_dependencies(arangobackup zlibstatic v8_build) # v8_build includes ICU build
else ()
  add_dependencies(arangobackup zlibstatic)
endif ()

if (USE_JEMALLOC)
  add_dependencies(arangobackup jemalloc_build)
endif ()

if (USE_FAIL_ON_WARNINGS)
 if (MSVC)
   target_compile_options(arangobackup PRIVATE /WX /D_WINSOCK_DEPRECATED_NO_WARNINGS)
 else ()
   target_compile_options(arangobackup PRIVATE -Werror -Wno-error=deprecated-declarations)
 endif ()
endif ()

endif () # USE_ENTERPRISE

################################################################################
## arangodump
################################################################################

if (MSVC AND NOT(SKIP_PACKAGING))
  generate_product_version(ProductVersionFiles_arangodump
    NAME arangodump
    FILE_DESCRIPTION ${ARANGO_DUMP_FRIENDLY_STRING}
    ICON ${ARANGO_ICON}
    VERSION_MAJOR ${CPACK_PACKAGE_VERSION_MAJOR}
    VERSION_MINOR ${CPACK_PACKAGE_VERSION_MINOR}
    VERSION_PATCH ${CPACK_PACKAGE_VERSION_PATCH}
    VERSION_REVISION ${BUILD_ID}
  )
endif ()

add_executable(${BIN_ARANGODUMP}
  ${ProductVersionFiles_arangodump}
  Dump/DumpFeature.cpp
  Dump/arangodump.cpp
  ${ADDITIONAL_BIN_ARANGODUMP_SOURCES}
)
target_include_directories(${BIN_ARANGODUMP} PRIVATE ${PROJECT_SOURCE_DIR}/arangosh)

target_link_libraries(${BIN_ARANGODUMP}
  arango
  ${MSVC_LIBS}
  ${SYSTEM_LIBRARIES}
  boost_system
  boost_boost
  arango_shell
  fuerte
)

install(
  TARGETS ${BIN_ARANGODUMP}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

install_config(arangodump)

if (NOT USE_PRECOMPILED_V8)
  add_dependencies(arangodump zlibstatic v8_build) # v8_build includes ICU build
else ()
  add_dependencies(arangodump zlibstatic)
endif ()

if (USE_JEMALLOC)
  add_dependencies(arangodump jemalloc_build)
endif ()

if (USE_FAIL_ON_WARNINGS)
 if (MSVC)
   target_compile_options(arangodump PRIVATE /WX /D_WINSOCK_DEPRECATED_NO_WARNINGS)
 else ()
   target_compile_options(arangodump PRIVATE -Werror -Wno-error=deprecated-declarations)
 endif ()
endif ()

################################################################################
## arangoexport
################################################################################

if (MSVC AND NOT(SKIP_PACKAGING))
  generate_product_version(ProductVersionFiles_arangoexport
    NAME arangoexport
    FILE_DESCRIPTION ${ARANGO_EXPORT_FRIENDLY_STRING}
    ICON ${ARANGO_ICON}
    VERSION_MAJOR ${CPACK_PACKAGE_VERSION_MAJOR}
    VERSION_MINOR ${CPACK_PACKAGE_VERSION_MINOR}
    VERSION_PATCH ${CPACK_PACKAGE_VERSION_PATCH}
    VERSION_REVISION ${BUILD_ID}
  )
endif ()

add_executable(${BIN_ARANGOEXPORT}
  ${ProductVersionFiles_arangoexport}
  Export/ExportFeature.cpp
  Export/arangoexport.cpp
)
target_include_directories(${BIN_ARANGOEXPORT} PRIVATE ${PROJECT_SOURCE_DIR}/arangosh)

target_link_libraries(${BIN_ARANGOEXPORT}
  arango
  ${MSVC_LIBS}
  ${SYSTEM_LIBRARIES}
  boost_system
  boost_boost
  arango_shell
)

install(
  TARGETS ${BIN_ARANGOEXPORT}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

install_config(arangoexport)

if (NOT USE_PRECOMPILED_V8)
  add_dependencies(arangoexport zlibstatic v8_build) # v8_build includes ICU build
else ()
  add_dependencies(arangoexport zlibstatic) # v8_build includes ICU build
endif ()

if (USE_JEMALLOC)
  add_dependencies(arangoexport jemalloc_build)
endif ()

if (USE_FAIL_ON_WARNINGS)
 if (MSVC)
   target_compile_options(arangoexport PRIVATE /WX /D_WINSOCK_DEPRECATED_NO_WARNINGS)
 else ()
   target_compile_options(arangoexport PRIVATE -Werror -Wno-error=deprecated-declarations)
 endif ()
endif ()

################################################################################
## arangoimport
################################################################################

if (MSVC AND NOT(SKIP_PACKAGING))
  generate_product_version(ProductVersionFiles_arangoimport
    NAME arangoimport
    FILE_DESCRIPTION ${ARANGO_IMPORT_FRIENDLY_STRING}
    ICON ${ARANGO_ICON}
    VERSION_MAJOR ${CPACK_PACKAGE_VERSION_MAJOR}
    VERSION_MINOR ${CPACK_PACKAGE_VERSION_MINOR}
    VERSION_PATCH ${CPACK_PACKAGE_VERSION_PATCH}
    VERSION_REVISION ${BUILD_ID}
  )
endif ()

add_executable(${BIN_ARANGOIMPORT}
  ${ProductVersionFiles_arangoimport}
  Import/AutoTuneThread.cpp
  Import/ImportFeature.cpp
  Import/ImportHelper.cpp
  Import/SenderThread.cpp
  Import/arangoimport.cpp
)
target_include_directories(${BIN_ARANGOIMPORT} PRIVATE ${PROJECT_SOURCE_DIR}/arangosh)

target_link_libraries(${BIN_ARANGOIMPORT}
  arango
  ${MSVC_LIBS}
  ${SYSTEM_LIBRARIES}
  boost_system
  boost_boost
  arango_shell
)

install(
  TARGETS arangoimport
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

install_config(arangoimport)

add_dependencies(arangoimport fuerte)

if (NOT USE_PRECOMPILED_V8)
  add_dependencies(arangoimport zlibstatic v8_build) # v8_build includes ICU
                                                     # build
else ()
  add_dependencies(arangoimport zlibstatic) # v8_build includes ICU build
endif ()

if (USE_JEMALLOC)
  add_dependencies(arangoimport jemalloc_build)
endif ()

install_command_alias(arangoimport
  ${CMAKE_INSTALL_BINDIR}
  arangoimp
)

if (USE_FAIL_ON_WARNINGS)
 if (MSVC)
   target_compile_options(arangoimport PRIVATE /WX /D_WINSOCK_DEPRECATED_NO_WARNINGS)
 else ()
   target_compile_options(arangoimport PRIVATE -Werror -Wno-error=deprecated-declarations)
 endif ()
endif ()

################################################################################
## arangorestore
################################################################################

if (MSVC AND NOT(SKIP_PACKAGING))
  generate_product_version(ProductVersionFiles_arangorestore
    NAME arangorestore
    FILE_DESCRIPTION ${ARANGO_RESTORE_FRIENDLY_STRING}
    ICON ${ARANGO_ICON}
    VERSION_MAJOR ${CPACK_PACKAGE_VERSION_MAJOR}
    VERSION_MINOR ${CPACK_PACKAGE_VERSION_MINOR}
    VERSION_PATCH ${CPACK_PACKAGE_VERSION_PATCH}
    VERSION_REVISION ${BUILD_ID}
  )
endif ()

add_executable(${BIN_ARANGORESTORE}
  ${ProductVersionFiles_arangorestore}
  Restore/RestoreFeature.cpp
  Restore/arangorestore.cpp
  ${ADDITIONAL_BIN_ARANGORESTORE_SOURCES}
)
target_include_directories(${BIN_ARANGORESTORE} PRIVATE ${PROJECT_SOURCE_DIR}/arangosh)

target_link_libraries(${BIN_ARANGORESTORE}
  arango
  ${MSVC_LIBS}
  ${SYSTEM_LIBRARIES}
  boost_system
  boost_boost
  arango_shell
  fuerte
)

install(
  TARGETS ${BIN_ARANGORESTORE}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

install_config(arangorestore)

if (NOT USE_PRECOMPILED_V8)
  add_dependencies(arangorestore zlibstatic v8_build) # v8_build includes ICU build
else ()
  add_dependencies(arangorestore zlibstatic) # v8_build includes ICU build
endif ()

if (USE_JEMALLOC)
  add_dependencies(arangorestore jemalloc_build)
endif ()

if (USE_FAIL_ON_WARNINGS)
 if (MSVC)
   target_compile_options(arangorestore PRIVATE /WX /D_WINSOCK_DEPRECATED_NO_WARNINGS)
 else ()
   target_compile_options(arangorestore PRIVATE -Werror -Wno-error=deprecated-declarations)
 endif ()
endif ()

################################################################################
## arangosh
################################################################################

if (MSVC AND NOT(SKIP_PACKAGING))
  generate_product_version(ProductVersionFiles_arangosh
    NAME arangosh
    FILE_DESCRIPTION ${ARANGOSH_FRIENDLY_STRING}
    ICON ${ARANGO_ICON}
    VERSION_MAJOR ${CPACK_PACKAGE_VERSION_MAJOR}
    VERSION_MINOR ${CPACK_PACKAGE_VERSION_MINOR}
    VERSION_PATCH ${CPACK_PACKAGE_VERSION_PATCH}
    VERSION_REVISION ${BUILD_ID}
  )
endif ()

add_executable(${BIN_ARANGOSH}
  ${ProductVersionFiles_arangosh}
  Import/AutoTuneThread.cpp
  Import/ImportHelper.cpp
  Import/SenderThread.cpp
  Shell/ShellFeature.cpp
  Shell/V8ClientConnection.cpp
  Shell/V8ShellFeature.cpp
  Shell/arangosh.cpp
)
target_include_directories(${BIN_ARANGOSH} PRIVATE ${PROJECT_SOURCE_DIR}/arangosh)

target_link_libraries(${BIN_ARANGOSH}
  arango_v8_deadline
  arango_v8
  arango
  ${LINENOISE_LIBS}
  ${V8_LIBS}
  fuerte
  ${MSVC_LIBS}
  ${SYSTEM_LIBRARIES}
  boost_system
  boost_boost
  arango_shell
)

install(
  TARGETS ${BIN_ARANGOSH}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

install_config(arangosh)

if (NOT USE_PRECOMPILED_V8)
  add_dependencies(arangosh zlibstatic v8_build)
else ()
  add_dependencies(arangosh zlibstatic)
endif ()

if (USE_JEMALLOC)
  add_dependencies(arangosh jemalloc_build)
endif ()

if (USE_FAIL_ON_WARNINGS)
 if (MSVC)
   target_compile_options(arangosh PRIVATE /WX /D_WINSOCK_DEPRECATED_NO_WARNINGS)
 else ()

=== lib/CMakeLists.txt ===
# -*- mode: CMAKE; -*-

include_directories(.)

################################################################################
## LIB_ARANGO
################################################################################

if (MSVC)
  set(LIB_ARANGO_MSVC
    Basics/locks-win32.cpp
    Basics/memory-map-win32.cpp
    Basics/terminal-utils-win32.cpp
    Basics/threads-win32.cpp
    Basics/win-utils.cpp
    Zip/iowin32.cpp
    ApplicationFeatures/WindowsServiceFeature.cpp
  )
else ()
  set(LIB_ARANGO_POSIX
    ApplicationFeatures/DaemonFeature.cpp
    ApplicationFeatures/SupervisorFeature.cpp
    Basics/locks-posix.cpp
    Basics/memory-map-posix.cpp
    Basics/terminal-utils-posix.cpp
    Basics/threads-posix.cpp
    Endpoint/EndpointUnixDomain.cpp
    Endpoint/EndpointSrv.cpp
  )
endif ()

set(LIB_ARANGO_LINENOISE
  ${PROJECT_SOURCE_DIR}/3rdParty/linenoise-ng/src/ConvertUTF.cpp
  ${PROJECT_SOURCE_DIR}/3rdParty/linenoise-ng/src/linenoise.cpp
  ${PROJECT_SOURCE_DIR}/3rdParty/linenoise-ng/src/wcwidth.cpp
  Utilities/LinenoiseShell.cpp
  Utilities/LineEditor.cpp
  Utilities/ShellBase.cpp
)

set(LIB_ARANGO_DATE
  ${PROJECT_SOURCE_DIR}/3rdParty/date/src/tz.cpp
)
add_definitions("-DHAS_REMOTE_API=0")


add_definitions("-DARCHITECTURE_OPTIMIZATIONS=${ARCHITECTURE_OPTIMIZATIONS}")

if (ASM_OPTIMIZATIONS AND CMAKE_TARGET_ARCHITECTURE_CODE MATCHES "x86_64")
  if (DARWIN)
    set(LIB_ASM_SOURCES Basics/crc1.S)
  else()
    set(LIB_ASM_SOURCES Basics/crc5.S)
  endif()

  add_definitions("-DENABLE_ASM_CRC32=1")
  message(STATUS "Will compile in hand-optimized assembler code for CRC32.")
else()
  add_definitions("-DENABLE_ASM_CRC32=0")
  message(STATUS "Will not compile in hand-optimized assembler code for CRC32.")
endif()

if (USE_LOCAL_CLOCK_GETTIME)
  set(LIB_CLOCK_GETTIME Utilities/clock_gettime.cpp)
endif ()

add_library(arango STATIC
  ${LIB_ARANGO_APPLE}
  ${LIB_ARANGO_MSVC}
  ${LIB_ARANGO_POSIX}
  ${LIB_ARANGO_LINENOISE}
  ${LIB_ARANGO_DATE}
  ${LIB_CLOCK_GETTIME}
  ${LIB_ASM_SOURCES}
  ApplicationFeatures/ApplicationFeature.cpp
  ApplicationFeatures/ApplicationFeaturePhase.cpp
  ApplicationFeatures/ApplicationServer.cpp
  ApplicationFeatures/ConfigFeature.cpp
  ApplicationFeatures/CommunicationFeaturePhase.cpp
  ApplicationFeatures/CpuUsageFeature.cpp
  ApplicationFeatures/EnvironmentFeature.cpp
  ApplicationFeatures/GreetingsFeature.cpp
  ApplicationFeatures/GreetingsFeaturePhase.cpp
  ApplicationFeatures/LanguageFeature.cpp
  ApplicationFeatures/TimeZoneFeature.cpp
  ApplicationFeatures/MaxMapCountFeature.cpp
  ApplicationFeatures/NonceFeature.cpp
  ApplicationFeatures/PrivilegeFeature.cpp
  ApplicationFeatures/SharedPRNGFeature.cpp
  ApplicationFeatures/ShellColorsFeature.cpp
  ApplicationFeatures/ShutdownFeature.cpp
  ApplicationFeatures/TempFeature.cpp
  ApplicationFeatures/V8PlatformFeature.cpp
  ApplicationFeatures/VersionFeature.cpp
  Basics/ArangoGlobalContext.cpp
  Basics/AttributeNameParser.cpp
  Basics/ConditionLocker.cpp
  Basics/ConditionVariable.cpp
  Basics/CpuUsageSnapshot.cpp
  Basics/CrashHandler.cpp
  Basics/DataProtector.cpp
  Basics/DebugRaceController.cpp
  Basics/EncodingUtils.cpp
  Basics/ErrorCode.cpp
  Basics/ResultError.cpp
  Basics/Exceptions.cpp
  Basics/FileUtils.cpp
  Basics/FunctionUtils.cpp
  Basics/GlobalResourceMonitor.cpp
  Basics/HybridLogicalClock.cpp
  Basics/LdapUrlParser.cpp
  Basics/LocalTaskQueue.cpp
  Basics/Mutex.cpp
  Basics/Nonce.cpp
  Basics/NumberOfCores.cpp
  Basics/NumberUtils.cpp
  Basics/PageSize.cpp
  Basics/PhysicalMemory.cpp
  Basics/ReadWriteLock.cpp
  Basics/ReadWriteSpinLock.cpp
  Basics/Result.cpp
  Basics/FileResult.cpp
  Basics/Identifier.cpp
  Basics/ResourceUsage.cpp
  Basics/RocksDBLogger.cpp
  Basics/RocksDBUtils.cpp
  Basics/StaticStrings.cpp
  Basics/StringBuffer.cpp
  Basics/StringHeap.cpp
  Basics/StringUtils.cpp
  Basics/Thread.cpp
  Basics/Utf8Helper.cpp
  Basics/VelocyPackHelper.cpp
  Basics/application-exit.cpp
  Basics/CleanupFunctions.cpp
  Basics/conversions.cpp
  Basics/csv.cpp
  Basics/datetime.cpp
  Basics/debugging.cpp
  Basics/error.cpp
  Basics/fasthash.cpp
  Basics/files.cpp
  Basics/fpconv.cpp
  Basics/hashes.cpp
  Basics/levenshtein.cpp
  Basics/memory.cpp
  Basics/process-utils.cpp
  Basics/signals.cpp
  Basics/socket-utils.cpp
  Basics/system-functions.cpp
  Basics/terminal-utils.cpp
  Basics/tri-strings.cpp
  Basics/tri-zip.cpp
  Basics/exitcodes.cpp
  Basics/xxhash.cpp
  Containers/MerkleTree.cpp
  Containers/MerkleTreeHelpers.cpp
  Endpoint/Endpoint.cpp
  Endpoint/EndpointIp.cpp
  Endpoint/EndpointIpV4.cpp
  Endpoint/EndpointIpV6.cpp
  Endpoint/EndpointList.cpp
  Futures/Future.cpp
  Logger/LogAppender.cpp
  Logger/LogAppenderFile.cpp
  Logger/LogAppenderSyslog.cpp
  Logger/LogBufferFeature.cpp
  Logger/LogLevel.cpp
  Logger/LogThread.cpp
  Logger/LogTopic.cpp
  Logger/Logger.cpp
  Logger/LoggerFeature.cpp
  Logger/LoggerStream.cpp
  Logger/LogTimeFormat.cpp
  Maskings/AttributeMasking.cpp
  Maskings/Collection.cpp
  Maskings/Maskings.cpp
  Maskings/Path.cpp
  Maskings/RandomMask.cpp
  Maskings/RandomStringMask.cpp
  ProgramOptions/Option.cpp
  ProgramOptions/Parameters.cpp
  ProgramOptions/ProgramOptions.cpp
  ProgramOptions/Section.cpp
  ProgramOptions/Translator.cpp
  ProgramOptions/IniFileParser.cpp
  Random/RandomFeature.cpp
  Random/RandomGenerator.cpp
  Random/UniformCharacter.cpp
  Rest/CommonDefines.cpp
  Rest/GeneralRequest.cpp
  Rest/GeneralResponse.cpp
  Rest/VstRequest.cpp
  Rest/VstResponse.cpp
  Rest/HttpRequest.cpp
  Rest/HttpResponse.cpp
  Rest/Version.cpp
  SimpleHttpClient/ClientConnection.cpp
  SimpleHttpClient/GeneralClientConnection.cpp
  SimpleHttpClient/SimpleHttpClient.cpp
  SimpleHttpClient/SimpleHttpResult.cpp
  SimpleHttpClient/SslClientConnection.cpp
  Ssl/SslFeature.cpp
  Ssl/SslInterface.cpp
  Ssl/ssl-helper.cpp
  Utilities/ScriptLoader.cpp
  Utilities/IsArangoExecutable.cpp
  Zip/ioapi.cpp
  Zip/unzip.cpp
  Zip/zip.cpp
  ${ADDITIONAL_LIB_ARANGO_SOURCES}
)

target_link_libraries(arango
  s2
  boost_system
  boost_boost
  velocypack
  ${V8_LIBS}
  ${SYSTEM_LIBRARIES}
)

set(FROZEN_INCLUDE_DIR "${PROJECT_SOURCE_DIR}/3rdParty/iresearch/external/frozen/include")

target_include_directories(arango PRIVATE ${FROZEN_INCLUDE_DIR})

add_dependencies(arango snappy-static)

set(SNAPPY_INCLUDE_DIR "${SNAPPY_SOURCE_DIR};${SNAPPY_BUILD_DIR}" CACHE PATH "relation to snappy")
include_directories(${SNAPPY_INCLUDE_DIR})

if (USE_LIBUNWIND)
  target_link_libraries(arango ${LIBUNWIND_LIB})
  target_include_directories(arango PRIVATE "${LIBUNWIND_HOME}/include")
  add_dependencies(arango libunwind_build)
endif ()

# Rebuild generated error files so they are up-to-date when all
# dependent stuff is built
if (USE_MAINTAINER_MODE)
  add_dependencies(arango errorfiles)
  add_dependencies(arango exitcodefiles)
endif ()


# Enterprise
if (USE_ENTERPRISE)
  target_compile_definitions(arango PUBLIC "-DUSE_ENTERPRISE=1")
  target_include_directories(arango PUBLIC "${PROJECT_SOURCE_DIR}/${ENTERPRISE_INCLUDE_DIR}")
endif()


################################################################################
## LIB_ARANGO_AIR_SOURCES
################################################################################

set(LIB_ARANGO_AIR_SOURCES
  Greenspun/Interpreter.cpp
  Greenspun/Primitives.cpp
  Greenspun/lib/DateTime.cpp
  Greenspun/lib/Math.cpp
  Greenspun/lib/Strings.cpp
  Greenspun/lib/Lists.cpp
  Greenspun/lib/Lists.h
  Greenspun/lib/Dicts.cpp
  Greenspun/lib/Dicts.h)

add_library(arango_greenspun STATIC
        ${LIB_ARANGO_AIR_SOURCES})

target_link_libraries(arango_greenspun immer)
target_link_libraries(arango_greenspun arango)

################################################################################
## LIB_ARANGO_GEO
################################################################################

add_library(arango_geo STATIC
  Geo/Ellipsoid.cpp
  Geo/GeoJson.cpp
  Geo/GeoParams.cpp
  Geo/ShapeContainer.cpp
  Geo/Shapes.cpp
  Geo/Utils.cpp
  Geo/karney/geodesic.c
  Geo/S2/S2MultiPointRegion.cpp
  Geo/S2/S2MultiPolyline.cpp
)

target_link_libraries(arango_geo
  arango
  boost_system
  boost_boost
  s2
)

if (WINDOWS)
  target_compile_options(arango_geo PUBLIC "-J")
endif()

# Enterprise
if (USE_ENTERPRISE)
  target_compile_definitions(arango_geo PUBLIC "-DUSE_ENTERPRISE=1")
  target_include_directories(arango_geo PUBLIC "${PROJECT_SOURCE_DIR}/${ENTERPRISE_INCLUDE_DIR}")
endif()

################################################################################
## LIB_ARANGO_V8
################################################################################

add_library(arango_v8 STATIC
  ApplicationFeatures/V8SecurityFeature.cpp
  V8/JavaScriptSecurityContext.cpp
  V8/JSLoader.cpp
  V8/V8LineEditor.cpp
  V8/v8-buffer.cpp
  V8/v8-conv.cpp
  V8/v8-globals.cpp
  V8/v8-shell.cpp
  V8/v8-utils.cpp
  V8/v8-vpack.cpp
  V8/v8-environment.cpp
  )
add_library(arango_v8_deadline STATIC
  V8/v8-deadline.cpp
  )

add_library(arango_v8_no_deadline STATIC
  V8/v8-no-deadline.cpp
  )

target_link_libraries(arango_v8
    boost_system
    boost_boost
)

# Enterprise
if (USE_ENTERPRISE)
  target_compile_definitions(arango_v8 PUBLIC "-DUSE_ENTERPRISE=1")
  target_include_directories(arango_v8 PUBLIC "${PROJECT_SOURCE_DIR}/${ENTERPRISE_INCLUDE_DIR}")
endif()

if (USE_FAIL_ON_WARNINGS)
  if (MSVC)
    target_compile_options(arango_v8 PRIVATE /WX /D_WINSOCK_DEPRECATED_NO_WARNINGS)
    target_compile_options(arango_geo PRIVATE /WX /D_WINSOCK_DEPRECATED_NO_WARNINGS96)
    target_compile_options(arango PRIVATE /WX /D_WINSOCK_DEPRECATED_NO_WARNINGS)
  else ()
    target_compile_options(arango_v8 PRIVATE -Werror -Wno-error=deprecated-declarations)
    target_compile_options(arango_geo PRIVATE -Werror -Wno-error=deprecated-declarations)
    target_compile_options(arango PRIVATE -Werror -Wno-error=deprecated-declarations)
  endif ()
endif ()

=== tests/CMakeLists.txt ===
include_directories(.)

# ----------------------------------------
# Greenspun tests
# ----------------------------------------

add_subdirectory(Greenspun)

# ----------------------------------------
# Fuerte tests
# ----------------------------------------

set(FUERTE_TESTS_SOURCES
  Fuerte/test_vst.cpp
  Fuerte/test_connection_basic.cpp
  Fuerte/test_connection_concurrent.cpp
  Fuerte/test_connection_failures.cpp
  Fuerte/test_connection_timeouts.cpp
#    test_10000_writes.cpp
)

add_executable(fuertetest
  ${FUERTE_TESTS_SOURCES}
  Fuerte/main.cpp
)

target_link_libraries(fuertetest
    fuerte
    gtest
    boost_boost
    arango
    arango_v8server
    ${MSVC_LIBS}
    ${OPENSSL_LIBRARIES}
    ${CMAKE_THREAD_LIBS_INIT}
)

target_include_directories(fuertetest SYSTEM PRIVATE
  ${V8_INTERNAL_INCLUDE_DIR}
  ${INCLUDE_DIRECTORIES}
  ${CMAKE_SOURCE_DIR}/3rdParty/fakeit-gtest
  ${CMAKE_SOURCE_DIR}/3rdParty/rocksdb/${ARANGO_ROCKSDB_VERSION}/third-party/gtest-1.8.1/fused-src
  ${CMAKE_SOURCE_DIR}/3rdParty/fuerte/src
)


# ----------------------------------------
# Link directories
# ----------------------------------------

foreach (LINK_DIR ${V8_LINK_DIRECTORIES})
  link_directories("${LINK_DIR}")
endforeach()

if (WINDOWS)
  set(RCFILE Maintenance/json.rc)
endif ()

set(ARANGODB_TESTS_COMMON_SOURCES
  ${CMAKE_CURRENT_SOURCE_DIR}/Mocks/IResearchLinkMock.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/Mocks/LogLevels.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/Mocks/PreparedResponseConnectionPool.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/Mocks/StorageEngineMock.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/Mocks/Servers.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/Basics/icu-helper.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/IResearch/AgencyMock.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/IResearch/common.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/IResearch/ExpressionContextMock.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/IResearch/RestHandlerMock.cpp
)

add_subdirectory(IResearch)

set(ARANGODB_TESTS_SOURCES
  ${ARANGODB_TESTS_COMMON_SOURCES}
  Agency/ActiveFailoverTest.cpp
  Agency/AddFollowerTest.cpp
  Agency/CleanOutServerTest.cpp
  Agency/CleanUpLostCollectionTest.cpp
  Agency/FailedFollowerTest.cpp
  Agency/FailedLeaderTest.cpp
  Agency/FailedServerTest.cpp
  Agency/MoveShardTest.cpp
  Agency/NodeTest.cpp
  Agency/RemoveFollowerTest.cpp
  Agency/StoreTest.cpp
  Agency/SupervisionTest.cpp
  Agency/TransactionBuilderTests.cpp
  Aql/AqlCallListTest.cpp
  Aql/AqlExecutorTestCase.cpp
  Aql/AqlSharedExecutionBlockImplTest.cpp
  Aql/AqlHelper.cpp
  Aql/AqlItemBlockInputRangeTest.cpp
  Aql/AqlItemBlockTest.cpp
  Aql/AqlItemMatrixTest.cpp
  Aql/AqlItemRowPrinter.cpp
  Aql/AqlItemRowTest.cpp
  Aql/AqlShadowRowTest.cpp
  Aql/AqlValueMemoryLayoutTest.cpp
  Aql/AttributeNamePathTest.cpp
  Aql/BitFunctionsTest.cpp
  Aql/BlockCollector.cpp
  Aql/CalculationExecutorTest.cpp
  Aql/CountCollectExecutorTest.cpp
  Aql/DateFunctionsTest.cpp
  Aql/FixedOutputExecutionBlockMock.cpp
  Aql/InRangeFunctionTest.cpp
  Aql/JaccardFunctionTest.cpp
  Aql/LevenshteinMatchFunctionTest.cpp
  Aql/DependencyProxyMock.cpp
  Aql/DistinctCollectExecutorTest.cpp
  Aql/EngineInfoContainerCoordinatorTest.cpp
  Aql/EnumerateCollectionExecutorTest.cpp
  Aql/EnumerateListExecutorTest.cpp
  Aql/ExecutionBlockImplTest.cpp
  Aql/ExecutionBlockImplTestInstances.cpp
  Aql/ExecutionNodeTest.cpp
  Aql/ExecutorTestHelper.cpp
  Aql/FilterExecutorTest.cpp
  Aql/GatherExecutorCommonTest.cpp
  Aql/HashedCollectExecutorTest.cpp
  Aql/IdExecutorTest.cpp
  Aql/IndexNodeTest.cpp
  Aql/InputRangeTest.cpp
  Aql/InsertExecutorTest.cpp
  Aql/KShortestPathsExecutorTest.cpp
  Aql/KShortestPathNodeTest.cpp
  Aql/LimitExecutorTest.cpp
  Aql/MockTypedNode.cpp
  Aql/NgramMatchFunctionTest.cpp
  Aql/NgramSimilarityFunctionTest.cpp
  Aql/NgramPosSimilarityFunctionTest.cpp
  Aql/NoResultsExecutorTest.cpp
  Aql/ProjectionsTest.cpp
  Aql/QueryHelper.cpp
  Aql/QueryCursorTest.cpp
  Aql/RegisterPlanTest.cpp
  Aql/RemoteExecutorTest.cpp
  Aql/RemoveExecutorTest.cpp
  Aql/ReplaceExecutorTest.cpp
  Aql/ReturnExecutorTest.cpp
  Aql/RowFetcherHelper.cpp
  Aql/ScatterExecutorTest.cpp
  Aql/ShortestPathExecutorTest.cpp
  Aql/ShortestPathNodeTest.cpp
  Aql/SkipResultTest.cpp
  Aql/SortedCollectExecutorTest.cpp
  Aql/SortExecutorTest.cpp
  Aql/SortLimit-test.cpp
  Aql/SpliceSubqueryOptimizerRuleTest.cpp
  Aql/SplicedSubqueryIntegrationTest.cpp
  Aql/SubqueryEndExecutorTest.cpp
  Aql/SubqueryStartExecutorTest.cpp
  Aql/TestEmptyExecutorHelper.cpp
  Aql/TestLambdaExecutor.cpp
  Aql/TraversalExecutorTest.cpp
  Aql/TraversalNodeTest.cpp
  Aql/UpdateExecutorTest.cpp
  Aql/UpsertExecutorTest.cpp
  Aql/VelocyPackHelper.cpp
  Aql/WaitingExecutionBlockMock.cpp
  Aql/WindowExecutorTest.cpp
  AsyncAgencyComm/AsyncAgencyCommTest.cpp
  Auth/UserManagerTest.cpp
  Auth/UserManagerClusterTest.cpp
  Basics/conversions-test.cpp
  Basics/csv-test.cpp
  Basics/datetime.cpp
  Basics/files-test.cpp
  Basics/fpconv-test.cpp
  Basics/hashes-test.cpp
  Basics/overload-test.cpp
  Basics/priorityqueue-test.cpp
  Basics/string-buffer-test.cpp
  Basics/string-test.cpp
  Basics/string-utf8-normalize-test.cpp
  Basics/string-utf8-test.cpp
  Basics/ApplicationServerTest.cpp
  Basics/AttributeNameParserTest.cpp
  Basics/CpuUsageSnapshotTest.cpp
  Basics/EndpointTest.cpp
  Basics/FixedSizeAllocatorTest.cpp
  Basics/InifileParserTest.cpp
  Basics/LoggerTest.cpp
  Basics/MemoryUsageTest.cpp
  Basics/NumberUtilsTest.cpp
  Basics/ParametersTest.cpp
  Basics/RandomTest.cpp
  Basics/ReadWriteLockTest.cpp
  Basics/RecursiveLockerTest.cpp
  Basics/SpinLockTest.cpp
  Basics/StringBufferTest.cpp
  Basics/StringUtilsTest.cpp
  Basics/VelocyPackHelper-test.cpp
  Cache/BucketState.cpp
  Cache/CachedValue.cpp
  Cache/FrequencyBuffer.cpp
  Cache/Manager.cpp
  Cache/Metadata.cpp
  Cache/MockScheduler.cpp
  Cache/PlainBucket.cpp
  Cache/PlainCache.cpp
  Cache/Rebalancer.cpp
  Cache/Table.cpp
  Cache/TransactionalBucket.cpp
  Cache/TransactionalCache.cpp
  Cache/TransactionalStore.cpp
  Cache/TransactionManager.cpp
  Cache/TransactionsWithBackingStore.cpp
  Cluster/AgencyPathsTest.cpp
  Cluster/ClusterHelpersTest.cpp
  Cluster/ClusterInfoTest.cpp
  Cluster/ClusterRepairsTest.cpp
  Cluster/RebootTrackerTest.cpp
  Cluster/QueryAnalyzerRevisions-test.cpp
  Containers/EnumerateTest.cpp
  Containers/HashSetTest.cpp
  Containers/MerkleTreeTest.cpp
  Futures/Future-test.cpp
  Futures/Promise-test.cpp
  Futures/Try-test.cpp
  Geo/GeoConstructorTest.cpp
  Geo/GeoFunctionsTest.cpp
  Geo/GeoJsonTest.cpp
  Geo/NearUtilsTest.cpp
  Geo/ShapeContainerTest.cpp
  Graph/ClusterTraverserCacheTest.cpp
  Graph/TraverserCacheTest.cpp
  Graph/ConstantWeightShortestPathFinder.cpp
  Graph/GenericGraphProviderTest.cpp
  Graph/GraphMockProviderInstances.cpp
  Graph/GraphTestTools.cpp
  Graph/KPathFinderTest.cpp
  Graph/KShortestPathsFinder.cpp
  Graph/MockGraph.cpp
  Graph/MockGraphProvider.cpp
  Graph/PathStoreTest.cpp
  Graph/PathValidatorTest.cpp
  Graph/QueueTest.cpp
  Graph/SingleServerProviderTest.cpp
  Greenspun/PrimitivesTest.cpp
  HotBackup/HotBackupCoordinatorTest.cpp
  ${ARANGODB_IRESEARCH_TESTS_SOURCES}
  Maintenance/MaintenanceFeatureTest.cpp
  Maintenance/MaintenanceRestHandlerTest.cpp
  Maintenance/MaintenanceTest.cpp
  ${RCFILE}
  Metrics/MetricsTest.cpp
  Metrics/MetricsFeatureTest.cpp
  Metrics/MetricsServerTest.cpp
  Network/ConnectionPoolTest.cpp
  Network/MethodsTest.cpp
  Network/UtilsTest.cpp
  Pregel/typedbuffer.cpp
  Replication/ReplicationClientsProgressTrackerTest.cpp
  RestHandler/RestAnalyzerHandler-test.cpp
  RestHandler/RestDocumentHandler-test.cpp
  RestHandler/RestUsersHandler-test.cpp
  RestHandler/RestViewHandler-test.cpp
  RestHandler/VstResponse-test.cpp
  RestServer/FlushFeature-test.cpp
  RocksDBEngine/Endian.cpp
  RocksDBEngine/KeyTest.cpp
  RocksDBEngine/HotBackupTest.cpp
  RocksDBEngine/EncryptionProviderTest.cpp
  RocksDBEngine/IndexEstimatorTest.cpp
  RocksDBEngine/ShaEventListener.cpp
  RocksDBEngine/TransactionManagerTest.cpp
  Sharding/ShardDistributionReporterTest.cpp
  StorageEngine/PhysicalCollectionTest.cpp
  Transaction/Context-test.cpp
  Transaction/CountCacheTest.cpp
  Transaction/Manager-test.cpp
  Transaction/RestTransactionHandler-test.cpp
  Utils/CollectionNameResolver-test.cpp
  V8Server/v8-analyzers-test.cpp
  V8Server/v8-users-test.cpp
  V8Server/v8-views-test.cpp
  VocBase/vocbase-test.cpp
  VocBase/KeyGenerator-test.cpp
  VocBase/LogicalDataSource-test.cpp
  VocBase/LogicalView-test.cpp
  VocBase/VersionTest.cpp
  VPackDeserializer/BasicTests.cpp)

if (USE_FAILURE_TESTS)
  # add test that depends on USE_FAILURE_TESTS
  set(ARANGODB_TESTS_SOURCES ${ARANGODB_TESTS_SOURCES} Aql/OldSubqueriesTest.cpp)
endif ()


if (LINUX)
  # add "-fno-var-tracking" to the compiler flags
  # this speeds up the compilation with optimizations and newer g++ versions
  # and prevents the "variable tracking size limit exceeded warnings" from
  # occurring
  if (CMAKE_COMPILER_IS_GNUCC)
    # also turn off super-expensive global common subexpression elimination for tests
    set_source_files_properties(${ARANGODB_TESTS_SOURCES} PROPERTIES COMPILE_FLAGS "-fno-var-tracking -fno-gcse")
  else ()
    set_source_files_properties(${ARANGODB_TESTS_SOURCES} PROPERTIES COMPILE_FLAGS -fno-var-tracking)
  endif ()
endif ()

add_executable(
  arangodbtests
  ${ARANGODB_TESTS_SOURCES}
  main.cpp
)

#required by fakeit dtor mock -- https://github.com/eranpeer/FakeIt/issues/84
if(CMAKE_CXX_COMPILER_ID STREQUAL GNU)
  target_compile_options(arangodbtests PRIVATE -fno-devirtualize)
endif()

target_link_libraries(arangodbtests
  arango_agency
  arango_cluster_engine
  arango_rocksdb
  arango_v8server
  arangoserver
  fuerte
  rocksdb
  snappy
  gtest
  boost_boost
)

if (USE_ENTERPRISE)
  target_link_libraries(arangodbtests arango_rclone)
endif()

target_include_directories(arangodbtests PRIVATE
  ${INCLUDE_DIRECTORIES}
)

if(MSVC AND USE_FAIL_ON_WARNINGS)
  target_compile_options(arangodbtests PRIVATE /WX /D_WINSOCK_DEPRECATED_NO_WARNINGS)
endif()

if (DARWIN AND USE_FAIL_ON_WARNINGS)
  # Missing Braces is broken in older CLangs - disable them here.
  target_compile_options(arangodbtests PRIVATE -Werror -Wno-error=deprecated-declarations -Wno-missing-braces)
endif()

# add these includes as system includes because otherwise
# the compiler will emit warnings for fakeit.hpp
target_include_directories(arangodbtests SYSTEM PRIVATE
  ${V8_INCLUDE_DIR}
  ${V8_INTERNAL_INCLUDE_DIR}
  ${CMAKE_SOURCE_DIR}/3rdParty/fakeit-gtest
  ${CMAKE_SOURCE_DIR}/3rdParty/rocksdb/${ARANGO_ROCKSDB_VERSION}/third-party/gtest-1.8.1/fused-src
)

if (USE_JEMALLOC)
  add_dependencies(arangodbtests jemalloc_build)
endif ()

find_package(OpenSSL REQUIRED)
list(APPEND IRESEARCH_LIB_RESOURCES
  "${LIB_EAY_DEBUG_DLL}"
  "${SSL_EAY_DEBUG_DLL}"
  "${LIB_EAY_RELEASE_DLL}"
  "${SSL_EAY_RELEASE_DLL}"
)

foreach(ELEMENT ${IRESEARCH_LIB_RESOURCES})
  add_custom_command(
    TARGET arangodbtests POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E echo "copying library resource:" "${ELEMENT}" " -> " "$<TARGET_FILE_DIR:arangodbtests>"
    COMMAND cp -lf ${ELEMENT} $<TARGET_FILE_DIR:arangodbtests> || ${CMAKE_COMMAND} -E copy ${ELEMENT} $<TARGET_FILE_DIR:arangodbtests>
  )
endforeach()

=== 3rdParty/V8/CMakeLists.txt ===
# -*- mode: CMAKE; -*-

# ------------------------------------------------------------------------------
# V8 / ICU
# ------------------------------------------------------------------------------

cmake_minimum_required(VERSION 2.8)

if (POLICY CMP0048)
  cmake_policy(SET CMP0048 NEW)
endif ()

project(V8)

# create target directory

set(V8_DIR "${PROJECT_SOURCE_DIR}/${V8_SUB_DIR}")
set(V8_TARGET_DIR "${CMAKE_CURRENT_BINARY_DIR}/${V8_SUB_DIR}")
set(GYP_FILES_DIR "${PROJECT_SOURCE_DIR}/gypfiles")

################################################################################
## ICU EXPORTS
################################################################################

set(ICU_COMPACT_VERSION
  "64.2"
  CACHE INTERNAL
  "ICU: compact Version"
)

set(ICU_VERSION
  "${ICU_COMPACT_VERSION}.1"
  CACHE INTERNAL
  "ICU: Version"
  )

set(ICU_BASEDIR ${V8_DIR}/third_party/icu)

set(ICU_INCLUDE_DIR
  ${ICU_BASEDIR}/source/common;${ICU_BASEDIR}/source/i18n;${ICU_BASEDIR}/source/io
  CACHE INTERNAL
  "ICU: include path"
  FORCE
)

set(V8_VERSION
  ${V8_VERSION}
  CACHE INTERNAL
  "${PROJECT_NAME}: Version"
)


SET(V8_RELATIVE_SOURCE_DIR "../${V8_SUB_DIR}")
file(MAKE_DIRECTORY ${V8_TARGET_DIR})

# detect endianess, and translate to gyp/v8 proper string

include(TestBigEndian)
TEST_BIG_ENDIAN(IS_BIGENDIAN)

if (${IS_BIGENDIAN})
  set(ENDIANESS 'big')
else()
  set(ENDIANESS 'little')
endif()

# detect 32bit or 64bit

if ("${CMAKE_TARGET_ARCHITECTURES}" STREQUAL "armv7")
  set(V8_PROC_ARCH "arm")
  set(QEMU_ARCH "qemu-arm")
  list(APPEND V8_GYP_ARGS -Darm_version=7 -Darm_fpu=default -Darm_float_abi=default)
elseif("${CMAKE_TARGET_ARCHITECTURES}" STREQUAL "aarch64")
  set(V8_PROC_ARCH "arm64")
  set(QEMU_ARCH "qemu-aarch64")
  list(APPEND V8_GYP_ARGS -Darm_fpu=default -Darm_float_abi=default)
else ()
  if ("${BITS}" STREQUAL "64")
    set(V8_PROC_ARCH "x64")
  else ()
    set(V8_PROC_ARCH "ia32")
  endif ()
endif()


# target architecture

file(RELATIVE_PATH V8_REL_TARGET_PATH ${V8_DIR} ${V8_TARGET_DIR})

list(APPEND V8_GYP_ARGS
  --generator-output=${V8_TARGET_DIR}
  -DV8_ROOT=${V8_RELATIVE_SOURCE_DIR}
  #$ ${V8_REL_TARGET_PATH}
  -Dv8_target_arch=${V8_PROC_ARCH}
  -Dv8_host_arch=${V8_PROC_ARCH}
  -Dbyteorder=${ENDIANESS}
  -Dv8_enable_i18n_support=1
  -DV8_SRC_ROOT=${GYP_FILES_DIR}/
)

if (CROSS_COMPILING)
  list(APPEND V8_GYP_ARGS
  -Dhost_arch=${V8_PROC_ARCH}
  -DGYP_CROSSCOMPILE=1
  -DEXECUTABLE_PREFIX=${V8_PROC_ARCH}.
  )
  configure_file (
    "${CMAKE_SOURCE_DIR}/lib/V8/v8-mkpeephole.in"
    "${V8_TARGET_DIR}/${V8_PROC_ARCH}.release/${V8_PROC_ARCH}.mkpeephole"
    NEWLINE_STYLE UNIX
    @ONLY
  )
  configure_file (
    "${CMAKE_SOURCE_DIR}/lib/V8/v8-mksnapshot.in"
    "${V8_TARGET_DIR}/${V8_PROC_ARCH}.release/${V8_PROC_ARCH}.mksnapshot"
    NEWLINE_STYLE UNIX
    @ONLY
  )
endif()

option(USE_DEBUG_V8 "compile V8 in DEBUG mode" OFF)
  
################################################################################
## WINDOWS with msbuild; Gyp now does TrackFileAccess too.
################################################################################

set(GYP_MAIN ${PROJECT_SOURCE_DIR}/gyp/gyp_main.py)

if (WIN32)
  MESSAGE(STATUS "Building V8 for Windows with MSBUILD")

  if (USE_CLCACHE_MODE)
    list(APPEND V8_GYP_ARGS "-Duse_clcache_mode=true")
  else ()
    list(APPEND V8_GYP_ARGS "-Duse_clcache_mode=false")
  endif()

  if (${CMAKE_GENERATOR} MATCHES "2013")
    # try to find 2013 in 'Visual Studio 12 2013 Win64'
    set(GYP_MSVS_VERSION "2013")
    MESSAGE(STATUS "setting GYP_MSVS_VERSION to 2013")
  elseif (${CMAKE_GENERATOR} MATCHES "2015")
    # try to find 2015 in 'Visual Studio 14 2015 Win64'
    set(GYP_MSVS_VERSION "2015")
    MESSAGE(STATUS "setting GYP_MSVS_VERSION to 2015")
  elseif (${CMAKE_GENERATOR} MATCHES "2017")
    # try to find 2017 in 'Visual Studio 15 2017 Win64'
    set(GYP_MSVS_VERSION "2017")
    MESSAGE(STATUS "setting GYP_MSVS_VERSION to 2017")
  elseif (${CMAKE_GENERATOR} MATCHES "2019")
    # try to find 2019 in 'Visual Studio 16 2019 Win64'
    set(GYP_MSVS_VERSION "2019")
    MESSAGE(STATUS "setting GYP_MSVS_VERSION to 2019")
  else ()
    set(GYP_MSVS_VERSION "2017")
    MESSAGE(STATUS "setting GYP_MSVS_VERSION to 2017 by default")
  endif()

  list(APPEND V8_GYP_ARGS "-Dmsvs_cygwin_shell=0")
  list(APPEND V8_GYP_ARGS "-Dv8_use_snapshot=true")

  if ("${BITS}" STREQUAL "64")
    set(MS_TARGET_PLATFORM x64)
  else ()
    set(MS_TARGET_PLATFORM Win32)
  endif ()

  list(APPEND V8_GYP_ARGS -Dtarget_arch=${V8_PROC_ARCH} -Dhost_arch=${V8_PROC_ARCH})
  list(APPEND V8_GYP_ARGS ../gypfiles/all.gyp)

  list(APPEND V8_TARGET_ARCHS "Release")
  
  if (USE_DEBUG_V8)
    list(APPEND V8_TARGET_ARCHS "Debug")
  endif()
  
  set(GYP_GENERATORS "msvs")
  set(DEPOT_TOOLS_WIN_TOOLCHAIN "0")
  set(GYP_MSVS_OVERRIDE_PATH "${CMAKE_CXX_COMPILER}")

  list(APPEND V8_GYP_ARGS
    -I../gypfiles/standalone.gypi
    -Dcomponent=static_library
    -Dlibrary=static_library
    -Dgenerator_output=${V8_TARGET_DIR}
    -Ggenerator_output=${V8_TARGET_DIR}
    --depth=.
    -Dwerror=
    -Dembed_script=
    -Dwarmup_script=
    -Dv8_enable_embedded_builtins=1
    -Dembedded_builtins_snapshot_src=
    -Dv8_enable_handle_zapping=0
    -Dv8_use_snapshot=1
    -DPYTHON_EXECUTABLE="${PYTHON_EXECUTABLE}"
    -Dnode_use_pch=false
    )

  list(APPEND V8_TARGETS
    torque
    run_torque
    generate_bytecode_builtins_list
    v8_libsampler
    v8_initializers
    v8_libplatform
    v8_nosnapshot
    mksnapshot
    v8_snapshot
    v8
    )

  add_custom_target(v8_build)
  set(V8_LIBS
    "v8_base_without_compiler;v8_compiler;v8_base_without_compiler;torque_base;v8_libplatform;v8_libsampler;v8_libbase;v8_init;v8_initializers;v8_nosnapshot"
    CACHE INTERNAL
    "${PROJECT_NAME}: Libraries"
  )

  foreach (MS_TARGET_CONF ${V8_TARGET_ARCHS})
    string(TOLOWER ${MS_TARGET_CONF} MS_TARGET_CONF_LOWER)
    ExternalProject_Add(v8_build_${MS_TARGET_CONF_LOWER}
      BUILD_IN_SOURCE
      TRUE
      WORKING_DIRECTORY
      ${V8_DIR}/gypfiles
      SOURCE_DIR
      "${V8_DIR}"
      CONFIGURE_COMMAND
        ${CMAKE_COMMAND} -E env GYP_MSVS_VERSION=${GYP_MSVS_VERSION} GYP_GENERATORS=${GYP_GENERATORS} GYP_MSVS_OVERRIDE_PATH=${GYP_MSVS_OVERRIDE_PATH} DEPOT_TOOLS_WIN_TOOLCHAIN=${DEPOT_TOOLS_WIN_TOOLCHAIN} "${PYTHON_EXECUTABLE}" ${GYP_MAIN} ${V8_GYP_ARGS} -Dmode=${MS_TARGET_CONF_LOWER}
      BUILD_COMMAND
      ""
      INSTALL_COMMAND
        ""
      )

    add_dependencies(v8_build v8_build_${MS_TARGET_CONF_LOWER})

    foreach(V8_ONE_TARGET ${V8_TARGETS})
      # cmake eats semicolons or quotes them or, or, or so we can't use /t:a;b;c
      ExternalProject_Add_Step(v8_build_${MS_TARGET_CONF_LOWER} v8_build_${V8_ONE_TARGET}_${MS_TARGET_CONF_LOWER}
        WORKING_DIRECTORY
          ${V8_TARGET_DIR}/../gypfiles
        COMMAND
          msbuild ${V8_ONE_TARGET}.vcxproj /p:Configuration=${MS_TARGET_CONF} /p:Platform=${MS_TARGET_PLATFORM}
#          msbuild All.vcxproj /p:Configuration=${MS_TARGET_CONF} /p:Platform=${MS_TARGET_PLATFORM}
        DEPENDEES
          configure
        DEPENDERS
          build
        )
    endforeach ()
  endforeach ()

  set(ICU_LIBRARY_DEBUG   "${CMAKE_CURRENT_BINARY_DIR}/${V8_SUB_DIR}/third_party/icu/Debug")
  set(ICU_LIBRARY_RELEASE "${CMAKE_CURRENT_BINARY_DIR}/${V8_SUB_DIR}/third_party/icu/Release")

  set(ICU_LIBS
    debug "${ICU_LIBRARY_DEBUG}/lib/icui18n.lib"
    optimized "${ICU_LIBRARY_RELEASE}/lib/icui18n.lib"

    debug "${ICU_LIBRARY_DEBUG}/lib/icuuc.lib"
    optimized "${ICU_LIBRARY_RELEASE}/lib/icuuc.lib"

    CACHE INTERNAL
    "ICU: Libraries"
    FORCE
    )

  
  set(V8_LIBRARY_DEBUG "${CMAKE_CURRENT_BINARY_DIR}/gypfiles/Debug")
  set(V8_LIBRARY_RELEASE "${CMAKE_CURRENT_BINARY_DIR}/gypfiles//Release")


  message("V8_LIBRARY_DEBUG ${V8_LIBRARY_DEBUG} CMAKE_CURRENT_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR}")
#v8_libplatform.lib
#v8_base_without_compiler.lib
#v8_libbase.lib
#v8_libsampler.lib
#v8_compiler.lib
#v8_snapshot.lib
#v8_initializers.lib

  set(V8_LIBS
    debug "${V8_LIBRARY_DEBUG}/lib/v8_libplatform.lib"
    optimized "${V8_LIBRARY_RELEASE}/lib/v8_libplatform.lib"

    debug "${V8_LIBRARY_DEBUG}/lib/v8_base_without_compiler.lib"
    optimized "${V8_LIBRARY_RELEASE}/lib/v8_base_without_compiler.lib"

    debug "${V8_LIBRARY_DEBUG}/lib/v8_libbase.lib"
    optimized "${V8_LIBRARY_RELEASE}/lib/v8_libbase.lib"

    debug "${V8_LIBRARY_DEBUG}/lib/v8_libsampler.lib"
    optimized "${V8_LIBRARY_RELEASE}/lib/v8_libsampler.lib"

    debug "${V8_LIBRARY_DEBUG}/lib/torque_base.lib"
    optimized "${V8_LIBRARY_RELEASE}/lib/torque_base.lib"

    debug "${V8_LIBRARY_DEBUG}/lib/v8_compiler.lib"
    optimized "${V8_LIBRARY_RELEASE}/lib/v8_compiler.lib"

    debug "${V8_LIBRARY_DEBUG}/lib/v8_initializers.lib"
    optimized "${V8_LIBRARY_RELEASE}/lib/v8_initializers.lib"

    debug "${V8_LIBRARY_DEBUG}/lib/v8_snapshot.lib"
    optimized "${V8_LIBRARY_RELEASE}/lib/v8_snapshot.lib"

#    debug "${V8_LIBRARY_DEBUG}/lib/v8_init.lib"
#    optimized "${V8_LIBRARY_RELEASE}/lib/v8_init.lib"

    debug "DbgHelp.lib"
    optimized "DbgHelp.lib"

    CACHE INTERNAL
    "${PROJECT_NAME}: Libraries"
    )
  set(V8_INCLUDE_DIR
    debug "${V8_DIR}/include;${V8_DIR};${V8_LIBRARY_DEBUG}/obj/global_intermediate/"
    optimized "${V8_DIR}/include;${V8_DIR};${V8_LIBRARY_RELEASE}/obj/global_intermediate/"
    CACHE INTERNAL
    "${PROJECT_NAME}: include path"
    )
  set(V8_INTERNAL_INCLUDE_DIR
    debug "${V8_DIR}/src/builtins;${V8_LIBRARY_DEBUG}/obj/global_intermediate/generate-bytecode-output-root;${V8_LIBRARY_DEBUG}/obj/global_intermediate/torque-output-root"
    optimized "${V8_DIR}/src/builtins;${V8_LIBRARY_RELEASE}/obj/global_intermediate/generate-bytecode-output-root;${V8_LIBRARY_RELEASE}/obj/global_intermediate/torque-output-root"
    CACHE INTERNAL
    "${PROJECT_NAME}: V8 private include path"
    )

  set(V8_LIBRARY_DEBUG "${CMAKE_CURRENT_BINARY_DIR}/gypfiles/Debug")
  set(V8_LIBRARY_RELEASE "${CMAKE_CURRENT_BINARY_DIR}/gypfiles//Release")

else ()


################################################################################
## UNIX
################################################################################

  set(V8_CFLAGS   "$ENV{V8_CFLAGS}")
  set(V8_CXXFLAGS "$ENV{V8_CXXFLAGS}")
  set(V8_LDFLAGS  "$ENV{V8_LDFLAGS}")
  
  # build V8 without debug information
  if (USE_MINIMAL_DEBUGINFO)
    set(V8_CFLAGS   "${V8_CFLAGS} -g0")
    set(V8_CXXFLAGS "${V8_CXXFLAGS} -g0")
  endif()

  list(APPEND V8_GYP_ARGS "-Dv8_use_snapshot=true")

  if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    set(V8_CFLAGS   "${V8_CFLAGS} -fno-delete-null-pointer-checks")
    set(V8_CXXFLAGS "${V8_CXXFLAGS} -fno-delete-null-pointer-checks")
  endif()

  if (USE_DEBUG_V8)
    set(V8_TARGET_ARCH "${V8_PROC_ARCH}.debug")
  else ()
    set(V8_TARGET_ARCH "${V8_PROC_ARCH}.release")
  endif ()

  if (USE_DEBUG_V8)
    list(APPEND V8_GYP_ARGS -Dv8_enable_backtrace=1)
  endif ()

  set(V8_LIBRARY_DIR "${V8_TARGET_DIR}/${V8_TARGET_ARCH}/")
  set(ICU_LIBRARY_DIR "${V8_LIBRARY_DIR}")

  list(APPEND V8_GYP_ARGS ../gypfiles/all.gyp)
  list(APPEND V8_GYP_ARGS --format make)
  list(APPEND V8_GYP_ARGS -S.${V8_TARGET_ARCH})

  set(V8_INTERNAL_INCLUDE_DIR "${V8_LIBRARY_DIR}/obj/gen/generate-bytecode-output-root;${V8_LIBRARY_DIR}/obj/gen/torque-output-root")
  if (LINUX)
    set(V8_LIBRARY_DIR "${V8_LIBRARY_DIR}/gypfiles")
    set(ICU_LIBRARY_DIR "${ICU_LIBRARY_DIR}/obj.target/third_party/icu")
  elseif (APPLE)
    set(V8_LIBRARY_DIR "${V8_LIBRARY_DIR}/")
    set(ICU_LIBRARY_DIR "${V8_LIBRARY_DIR}/")
  endif ()

  list(APPEND V8_GYP_ARGS
    -I../gypfiles/standalone.gypi
    -Dmac_deployment_target=${CMAKE_OSX_DEPLOYMENT_TARGET}
    --depth=.
    -Dstandalone_static_library=1
    -Dlinux_use_bundled_gold=0
    -Dlinux_use_gold_flags=0
    -Dv8_no_strict_aliasing=1
    -Dwerror=
    -Dclang=0
    -Dhost_clang=
    -Dv8_embed_script=
    -Dembed_script=
    -Dwarmup_script=

=== 3rdParty/boost/CMakeLists.txt ===
project(boost)

#the boost version must also be adjusted in the top-level CMakeLists.txt file
set(boost_version "1.71.0")
set(BOOST_VERSION ${boost_version} PARENT_SCOPE)
set(boost_src "${CMAKE_CURRENT_SOURCE_DIR}/${boost_version}")

#create interface target for boost header only libraries
message(STATUS "using 3rdParty BOOST")
add_library(boost_boost INTERFACE)
target_include_directories(boost_boost SYSTEM INTERFACE "${boost_src}")

add_library(boost_filesystem STATIC
    ${boost_src}/libs/filesystem/src/codecvt_error_category.cpp
    ${boost_src}/libs/filesystem/src/operations.cpp
    ${boost_src}/libs/filesystem/src/path.cpp
    ${boost_src}/libs/filesystem/src/path_traits.cpp
    ${boost_src}/libs/filesystem/src/portability.cpp
    ${boost_src}/libs/filesystem/src/unique_path.cpp
    ${boost_src}/libs/filesystem/src/utf8_codecvt_facet.cpp
    ${boost_src}/libs/filesystem/src/windows_file_codecvt.cpp
)
target_link_libraries(boost_filesystem PUBLIC boost_boost) #this will add required includes
target_compile_definitions(boost_filesystem PRIVATE "BOOST_SYSTEM_STATIC_LINK=1")
target_compile_definitions(boost_filesystem PUBLIC  "BOOST_ALL_NO_LIB=1")

if(MSVC)
  list(APPEND BOOST_LOCALE_PLATFORM_DEFINE "BOOST_LOCALE_NO_POSIX_BACKEND=1")
  list(APPEND BOOST_LOCALE_PLATFORM_SRC
    ${boost_src}/libs/locale/src/win32/collate.cpp
    ${boost_src}/libs/locale/src/win32/converter.cpp
    ${boost_src}/libs/locale/src/win32/lcid.cpp
    ${boost_src}/libs/locale/src/win32/numeric.cpp
    ${boost_src}/libs/locale/src/win32/win_backend.cpp
  )
elseif(APPLE)
  list(APPEND BOOST_LOCALE_PLATFORM_DEFINE "BOOST_LOCALE_NO_WINAPI_BACKEND=1" "BOOST_LOCALE_WITH_ICU=1") # do not use 'iconv' on MacOS, hence must use ICU instead
  list(APPEND BOOST_LOCALE_PLATFORM_SRC
    ${boost_src}/libs/locale/src/posix/codecvt.cpp
    ${boost_src}/libs/locale/src/posix/collate.cpp
    ${boost_src}/libs/locale/src/posix/converter.cpp
    ${boost_src}/libs/locale/src/posix/numeric.cpp
    ${boost_src}/libs/locale/src/posix/posix_backend.cpp
  )
else()
  list(APPEND BOOST_LOCALE_PLATFORM_DEFINE "BOOST_LOCALE_NO_WINAPI_BACKEND=1" "BOOST_LOCALE_WITH_ICONV=1")
  list(APPEND BOOST_LOCALE_PLATFORM_SRC
    ${boost_src}/libs/locale/src/posix/codecvt.cpp
    ${boost_src}/libs/locale/src/posix/collate.cpp
    ${boost_src}/libs/locale/src/posix/converter.cpp
    ${boost_src}/libs/locale/src/posix/numeric.cpp
    ${boost_src}/libs/locale/src/posix/posix_backend.cpp
  )
endif()

#build boost_locale - add more source files as needed
add_library(boost_locale STATIC
    ${boost_src}/libs/locale/src/encoding/codepage.cpp
    ${boost_src}/libs/locale/src/icu/boundary.cpp
    ${boost_src}/libs/locale/src/icu/codecvt.cpp
    ${boost_src}/libs/locale/src/icu/collator.cpp
    ${boost_src}/libs/locale/src/icu/conversion.cpp
    ${boost_src}/libs/locale/src/icu/date_time.cpp
    ${boost_src}/libs/locale/src/icu/formatter.cpp
    ${boost_src}/libs/locale/src/icu/icu_backend.cpp
    ${boost_src}/libs/locale/src/icu/numeric.cpp
    ${boost_src}/libs/locale/src/icu/time_zone.cpp
    ${boost_src}/libs/locale/src/shared/date_time.cpp
    ${boost_src}/libs/locale/src/shared/format.cpp
    ${boost_src}/libs/locale/src/shared/formatting.cpp
    ${boost_src}/libs/locale/src/shared/generator.cpp
    ${boost_src}/libs/locale/src/shared/ids.cpp
    ${boost_src}/libs/locale/src/shared/localization_backend.cpp
    ${boost_src}/libs/locale/src/shared/message.cpp
    ${boost_src}/libs/locale/src/shared/mo_lambda.cpp
    ${boost_src}/libs/locale/src/std/codecvt.cpp
    ${boost_src}/libs/locale/src/std/collate.cpp
    ${boost_src}/libs/locale/src/std/converter.cpp
    ${boost_src}/libs/locale/src/std/numeric.cpp
    ${boost_src}/libs/locale/src/std/std_backend.cpp
    ${boost_src}/libs/locale/src/util/codecvt_converter.cpp
    ${boost_src}/libs/locale/src/util/default_locale.cpp
    ${boost_src}/libs/locale/src/util/gregorian.cpp
    ${boost_src}/libs/locale/src/util/info.cpp
    ${boost_src}/libs/locale/src/util/locale_data.cpp
    ${BOOST_LOCALE_PLATFORM_SRC}
)
add_dependencies(boost_locale v8_build) # for ICU libs
target_link_libraries(boost_locale PUBLIC boost_boost) #this will add required includes
target_include_directories(boost_locale SYSTEM PRIVATE ${ICU_INCLUDE_DIR})
target_compile_definitions(boost_locale PRIVATE "BOOST_SYSTEM_STATIC_LINK=1")
target_compile_definitions(boost_locale PUBLIC  "BOOST_ALL_NO_LIB=1")

if(APPLE)
  target_link_libraries(boost_locale PUBLIC boost_thread) # must link against boost_thread due to use of ICU on MacOS
endif()

foreach(ELEMENT ${BOOST_LOCALE_PLATFORM_DEFINE})
  target_compile_definitions(boost_locale PRIVATE "${ELEMENT}")
endforeach()

#build boost_program_options - add more source files as needed
add_library(boost_program_options STATIC
    ${boost_src}/libs/program_options/src/cmdline.cpp
    ${boost_src}/libs/program_options/src/config_file.cpp
    ${boost_src}/libs/program_options/src/convert.cpp
    ${boost_src}/libs/program_options/src/options_description.cpp
    ${boost_src}/libs/program_options/src/parsers.cpp
    ${boost_src}/libs/program_options/src/positional_options.cpp
    ${boost_src}/libs/program_options/src/split.cpp
    ${boost_src}/libs/program_options/src/utf8_codecvt_facet.cpp
    ${boost_src}/libs/program_options/src/value_semantic.cpp
    ${boost_src}/libs/program_options/src/variables_map.cpp
    ${boost_src}/libs/program_options/src/winmain.cpp
)
target_link_libraries(boost_program_options PUBLIC boost_boost) #this will add required includes
target_compile_definitions(boost_program_options PRIVATE "BOOST_SYSTEM_STATIC_LINK=1")
target_compile_definitions(boost_program_options PUBLIC  "BOOST_ALL_NO_LIB=1")

#build boost_system - there seems to be just one cpp file:)
add_library(boost_system STATIC
    ${boost_src}/libs/system/src/error_code.cpp
)
target_link_libraries(boost_system PUBLIC boost_boost) #this will add required includes
target_compile_definitions(boost_system PRIVATE "BOOST_SYSTEM_STATIC_LINK=1")
target_compile_definitions(boost_system PUBLIC  "BOOST_ALL_NO_LIB=1")

if(MSVC)
  list(APPEND BOOST_THREAD_PLATFORM_SRC
    ${boost_src}/libs/thread/src/win32/thread.cpp
    ${boost_src}/libs/thread/src/win32/tss_dll.cpp
    ${boost_src}/libs/thread/src/win32/tss_pe.cpp
  )
else()
  list(APPEND BOOST_THREAD_PLATFORM_SRC
    ${boost_src}/libs/thread/src/pthread/once.cpp
    ${boost_src}/libs/thread/src/pthread/once_atomic.cpp
    ${boost_src}/libs/thread/src/pthread/thread.cpp
  )
endif()

#build boost_thread - add more source files as needed
add_library(boost_thread STATIC
    ${boost_src}/libs/thread/src/future.cpp
    ${boost_src}/libs/thread/src/tss_null.cpp
    ${BOOST_THREAD_PLATFORM_SRC}
)
target_link_libraries(boost_thread PUBLIC boost_boost) #this will add required includes
target_link_libraries(boost_locale PUBLIC boost_thread)
target_compile_definitions(boost_thread PRIVATE "BOOST_SYSTEM_STATIC_LINK=1")
target_compile_definitions(boost_thread PUBLIC  "BOOST_ALL_NO_LIB=1")

=== 3rdParty/date/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.0.2 )

project( date_prj )

find_package( Threads REQUIRED )

enable_testing( )

option( USE_SYSTEM_TZ_DB "Use the operating system's timezone database" OFF )
option( USE_TZ_DB_IN_DOT "Save the timezone database in the current folder" OFF )
option( BUILD_TZ_STATIC  "Build a static version of library" ON )

function( print_option OPT )
	if ( NOT DEFINED PRINT_OPTION_CURR_${OPT} OR ( NOT PRINT_OPTION_CURR_${OPT} STREQUAL ${OPT} ) )
		set( PRINT_OPTION_CURR_${OPT} ${${OPT}} CACHE BOOL "" )
		mark_as_advanced(PRINT_OPTION_CURR_${OPT})
		message( "# date: ${OPT} ${${OPT}}" )
	endif( )
endfunction( )

print_option( USE_SYSTEM_TZ_DB )
print_option( USE_TZ_DB_IN_DOT )
print_option( BUILD_TZ_STATIC  )

if( USE_SYSTEM_TZ_DB )
	add_definitions( -DUSE_AUTOLOAD=0 )
	add_definitions( -DHAS_REMOTE_API=0 )
	# cannot set USE_OS_TZDB to 1 on Windows
	if( NOT WIN32 )
		add_definitions( -DUSE_OS_TZDB=1 )
	endif( )
else( )
	add_definitions( -DUSE_AUTOLOAD=1 )
	add_definitions( -DHAS_REMOTE_API=1 )
	add_definitions( -DUSE_OS_TZDB=0 )
	find_package( CURL REQUIRED )
	include_directories( SYSTEM ${CURL_INCLUDE_DIRS} )
	set( OPTIONAL_LIBRARIES ${CURL_LIBRARIES} )
endif( )

if( USE_TZ_DB_IN_DOT )
	add_definitions( -DINSTALL=. )
endif( )

set( HEADER_FOLDER "include" )
set( SOURCE_FOLDER "src" )
set( TEST_FOLDER "test" )

# This is needed so IDE's live MSVC show header files
set( HEADER_FILES
	${HEADER_FOLDER}/date/chrono_io.h
	${HEADER_FOLDER}/date/date.h
	${HEADER_FOLDER}/date/ios.h
	${HEADER_FOLDER}/date/islamic.h
	${HEADER_FOLDER}/date/iso_week.h
	${HEADER_FOLDER}/date/julian.h
	${HEADER_FOLDER}/date/tz.h
	${HEADER_FOLDER}/date/tz_private.h
)

if( BUILD_TZ_STATIC )
	add_library( tz STATIC ${HEADER_FILES} ${SOURCE_FOLDER}/tz.cpp )
else( )
	add_library( tz SHARED ${HEADER_FILES} ${SOURCE_FOLDER}/tz.cpp )
endif( )

if ( ${CMAKE_MINOR_VERSION} GREATER 7 )
  set( TZ_CXX_STANDARD 17 )
else( )
  set( TZ_CXX_STANDARD 14 )
endif( )

set_property(TARGET tz PROPERTY CXX_STANDARD ${TZ_CXX_STANDARD})
target_link_libraries( tz ${CMAKE_THREAD_LIBS_INIT} ${OPTIONAL_LIBRARIES} )

# add include folders to the library and targets that consume it
target_include_directories(tz PUBLIC
    $<BUILD_INTERFACE:
        ${CMAKE_CURRENT_SOURCE_DIR}/${HEADER_FOLDER}
    >
    $<INSTALL_INTERFACE:
        include
    >
)

add_library(date_interface INTERFACE) # an interface (not a library), to enable automatic include_directory (for when just date.h, but not "tz.h and its lib" are needed)

# add include folders to the INTERFACE and targets that consume it
target_include_directories(date_interface INTERFACE
    $<BUILD_INTERFACE:
        ${CMAKE_CURRENT_SOURCE_DIR}/${HEADER_FOLDER}
    >
    $<INSTALL_INTERFACE:
        include
    >
)


install( TARGETS tz DESTINATION lib )
install( DIRECTORY ${HEADER_FOLDER}/ DESTINATION include/ )

add_custom_target( testit COMMAND ${CMAKE_CTEST_COMMAND} )

add_dependencies( testit tz )
function( add_pass_tests TEST_GLOB TEST_PREFIX )
	file( GLOB_RECURSE FILENAMES ${TEST_GLOB} )
	include_directories( "${HEADER_FOLDER}/date" )

	foreach( TEST_FILE ${FILENAMES} )
		get_filename_component( TEST_NAME ${TEST_FILE} NAME_WE )
		get_filename_component( TEST_EXT ${TEST_FILE} EXT )
		if( NOT ${TEST_EXT} STREQUAL ".fail.cpp" )
			set( PREFIX "${TEST_PREFIX}_pass_${TEST_NAME}" )
			set( BIN_NAME ${PREFIX}_bin )
			set( TST_NAME ${PREFIX}_test )
			add_executable( ${BIN_NAME} EXCLUDE_FROM_ALL ${TEST_FILE} )
			set_property(TARGET ${BIN_NAME} PROPERTY CXX_STANDARD ${TZ_CXX_STANDARD})
			add_test( ${TST_NAME} ${BIN_NAME} )
			target_link_libraries( ${BIN_NAME} tz )
			add_dependencies( testit ${BIN_NAME} )
		endif( )
	endforeach( )
endfunction( )

function( add_fail_tests TEST_GLOB TEST_PREFIX )
	file( GLOB_RECURSE FILENAMES ${TEST_GLOB} )

	foreach( TEST_FILE ${FILENAMES} )
		get_filename_component( TEST_NAME ${TEST_FILE} NAME_WE )
		get_filename_component( TEST_EXT ${TEST_FILE} EXT )

			set( TEST_TYPE "_fail" )

		set( PREFIX "${TEST_PREFIX}_fail_${TEST_NAME}" )
		set( BIN_NAME ${PREFIX}_bin )
		set( TST_NAME ${PREFIX}_test )

		#target_compile_definitions( ${BIN_NAME} PRIVATE ${TST_NAME} )
		set( TEST_BIN_NAME ${CMAKE_BINARY_DIR}/${BIN_NAME} )
		add_custom_target( ${BIN_NAME}
			COMMAND ${PROJECT_SOURCE_DIR}/compile_fail.sh ${TEST_BIN_NAME} ${CMAKE_CXX_COMPILER} -std=c++17 -L${CMAKE_BINARY_DIR}/ -ltz -I${PROJECT_SOURCE_DIR}/${HEADER_FOLDER}/date -o ${BIN_NAME} ${TEST_FILE}
			WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
			COMMENT ${TST_NAME}
			)
		add_test( ${TST_NAME} "${PROJECT_SOURCE_DIR}/test_fail.sh" ${CMAKE_BINARY_DIR}/${BIN_NAME} WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}/" )
		#set_tests_properties( ${TST_NAME} PROPERTIES WILL_FAIL TRUE)
		add_dependencies( testit ${BIN_NAME} )
	endforeach( )
endfunction( )

file( GLOB children RELATIVE "${PROJECT_SOURCE_DIR}/${TEST_FOLDER}" "${PROJECT_SOURCE_DIR}/${TEST_FOLDER}/*" )
foreach( child ${children} )
	if( IS_DIRECTORY "${PROJECT_SOURCE_DIR}/${TEST_FOLDER}/${child}" )
		set( CUR_FOLDER "${PROJECT_SOURCE_DIR}/${TEST_FOLDER}/${child}" )
		add_pass_tests( "${CUR_FOLDER}/*.cpp" ${child} )
		if( NOT WIN32 )
			add_fail_tests( "${CUR_FOLDER}/*.fail.cpp" ${child} )
		endif( )
	endif( )
endforeach( )

=== 3rdParty/iresearch/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8.2 FATAL_ERROR)

# we use of xxx_ROOT variables for modules sources search
if (POLICY CMP0074)
  cmake_policy(SET CMP0074 OLD)
endif()

################################################################################
### set required standard version
################################################################################

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

################################################################################
### interprocedural optimization (link time optimization)
################################################################################

set(IPO_ENABLED False)

if (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} VERSION_GREATER 3.8)
  set(USE_IPO AUTO CACHE STRING "Use interprocedural optimization: ON, OFF or AUTO")
  set_property(CACHE USE_IPO PROPERTY STRINGS AUTO ON OFF)

  # Determine value if IPO_ENABLED from USE_IPO and CMAKE_BUILD_TYPE
  if(USE_IPO STREQUAL "AUTO")
    # When USE_IPO=AUTO, enable IPO for optimized / release builds.
    # But to work around a g++ segfault triggered by using both -flto and
    # -fno-devirtualize-functions, we disable IPO when using google tests, because
    # this will set no-devirtualize. See
    # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=91387 and
    # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=91375.
    # So this check may be removed later as soon as we use fixed gcc versions.
    # - Tobias, 2019-08-08
    if (CMAKE_BUILD_TYPE STREQUAL "Release"
        OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo"
        OR CMAKE_BUILD_TYPE STREQUAL "MinSizeRel")
      set(IPO_ENABLED True)
    else()
      set(IPO_ENABLED False)
    endif ()
  elseif(USE_IPO)
    set(IPO_ENABLED True)
  else()
    set(IPO_ENABLED False)
  endif()
endif()

if (IPO_ENABLED)
  cmake_minimum_required(VERSION 3.9 FATAL_ERROR) # ensured by check above

  macro(SET_IPO _target)
    set_property(TARGET ${_target} PROPERTY INTERPROCEDURAL_OPTIMIZATION ${IPO_ENABLED})
  endmacro()
else()
  macro(SET_IPO _target)
    # NOOP
  endmacro()
endif()

message(STATUS "IPO_ENABLED: ${IPO_ENABLED}")

set(IResearch_TARGET_NAME "iresearch" CACHE INTERNAL "")
project(${IResearch_TARGET_NAME})

# attach additional cmake modules
list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

# load cmake utils
include(Utils)
include(PVS-Studio)

if (NOT MSVC)
  # put GCC version into GCC_VERSION variable
  execute_process(COMMAND ${CMAKE_C_COMPILER} -dumpversion OUTPUT_VARIABLE GCC_VERSION)
endif()

################################################################################
### compile options
################################################################################

option(USE_PVS_STUDIO "Generate target for PVS-Studio check" OFF)
option(USE_CLANG_TIDY "Include clang-tidy checks" OFF)
option(USE_IWYU "Include IWYU checks" OFF)
option(USE_TESTS "Build tests" OFF)
option(USE_PYRESEARCH "Build iresearch python bridge" OFF)
option(USE_VALGRIND "Use workarounds to avoid false positives in valgrind" OFF)
option(USE_SIMDCOMP "Use architecture specific low-level optimizations" OFF)
option(USE_CCACHE "Use CCACHE if present" ON)
option(USE_MICRO_BENCHMARCH "Build micro-benchmark project" OFF)

set(SUPPRESS_EXTERNAL_WARNINGS OFF CACHE INTERNAL "Suppress warnings originating in 3rd party code.")

add_option_gprof(FALSE)

if (USE_VALGRIND)
  add_definitions(-DIRESEARCH_VALGRIND)
endif()

if (MSVC)
  # FIXME TODO find a workaround or do not use alignas(...)
  # MSVC2017.1 - MSVC2018.7 does not correctly support alignas()
  # MSVC2017.8 requires the following define
  add_definitions(-D_ENABLE_EXTENDED_ALIGNED_STORAGE)
  
  # min/max macros interferes with our codebase
  add_definitions(-DNOMINMAX)

  if (MSVC_BUILD_THREADS)
    set(CMAKE_C_FLAGS "/MP${MSVC_BUILD_THREADS} ${CMAKE_C_FLAGS}")
    set(CMAKE_CXX_FLAGS "/MP${MSVC_BUILD_THREADS} ${CMAKE_CXX_FLAGS}")
  else ()
    set(CMAKE_C_FLAGS "/MP ${CMAKE_C_FLAGS}")
    set(CMAKE_CXX_FLAGS "/MP ${CMAKE_CXX_FLAGS}")
  endif()
endif()

################################################################################
### setup clang-tidy
################################################################################

unset(CLANG_TIDY_EXE CACHE)

if (USE_CLANG_TIDY)
  find_program(
    CLANG_TIDY_EXE
    NAMES "clang-tidy"
    DOC "Path to clang-tidy executable"
  )

  if(CLANG_TIDY_EXE)
    message(STATUS "clang-tidy found: ${CLANG_TIDY_EXE}")
  else()
    message(STATUS "clang-tidy not found.")
  endif()
endif()

################################################################################
### setup IWYU
################################################################################

unset(IWYU_PATH)

if (USE_IWYU)
  find_program(IWYU_PATH NAMES include-what-you-use iwyu)

  if(NOT IWYU_PATH)
    message(FATAL_ERROR "Could not find the program include-what-you-use")
  endif()
endif()

################################################################################
### setup ccache
################################################################################

if (USE_CCACHE)
  find_program(CCACHE_FOUND ccache)

  if(CCACHE_FOUND)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
  endif(CCACHE_FOUND)
endif()

################################################################################
### setup platform dependent optimizations
################################################################################

if (USE_SIMDCOMP)
  include(OptimizeForArchitecture)
  OptimizeForArchitecture()

  add_definitions(${Vc_ARCHITECTURE_FLAGS})
endif()

################################################################################
### find 3rd party libraries
################################################################################

# find Boost
find_package(BoostLocal REQUIRED)

# set pthread library
if (NOT MSVC)
  set(PTHREAD_LIBRARY pthread)
endif()

# set gcov library
if (NOT MSVC AND (CMAKE_BUILD_TYPE STREQUAL "Coverage"))
  set(GCOV_LIBRARY gcov)
endif()

# set sanitizers
find_package(Sanitizers)

#find BFD
find_package(BFD
  #OPTIONAL
)

if (BFD_FOUND)
  add_definitions(-DUSE_LIBBFD)
else()
  set(BFD_INCLUDE_DIR "")
  set(BFD_SHARED_LIBS "")
  set(BFD_STATIC_LIBS "")
  set(BFD_SHARED_LIB_RESOURCES "")
endif()

# find LZ4
find_package(Lz4
  REQUIRED
)

# find ICU
find_package(ICU
  REQUIRED
)

# find Snowball
find_package(Snowball
  REQUIRED
)

# find Unwind
find_package(Unwind
  #OPTIONAL
)

if (Unwind_FOUND)
  add_definitions(-DUSE_LIBUNWIND)
else()
  set(Unwind_INCLUDE_DIR "")
  set(Unwind_SHARED_LIBS "")
  set(Unwind_STATIC_LIBS "")
  set(Unwind_SHARED_LIB_RESOURCES "")
endif()

# set external dirs
set(EXTERNAL_INCLUDE_DIRS 
  ${PROJECT_SOURCE_DIR}/external
  CACHE INTERNAL 
  ""
)

set(IResearch_INCLUDE_DIR 
  "${PROJECT_SOURCE_DIR}/core"
  CACHE INTERNAL
  ""
)

# set output directories
set(EXECUTABLE_OUTPUT_PATH
  ${CMAKE_BINARY_DIR}/bin
  CACHE PATH
  "Executable output path"
)

set(LIBRARY_OUTPUT_PATH
  ${CMAKE_BINARY_DIR}/bin
  CACHE PATH 
  "Library output path"
)

mark_as_advanced( 
  EXECUTABLE_OUTPUT_PATH 
  LIBRARY_OUTPUT_PATH
)

add_definitions(-DUNICODE -D_UNICODE)

# set test resource directory
set(IResearch_test_resource_dir
  ${CMAKE_CURRENT_SOURCE_DIR}/tests/resources
)

# generate tests_config.hpp here instead of inside 'tests' to make available externally
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/tests/tests_config.hpp.in"
  "${CMAKE_CURRENT_BINARY_DIR}/tests/tests_config.hpp"
)

add_subdirectory(external)
add_subdirectory(core)
add_subdirectory(utils)

if (USE_PYRESEARCH)
  add_subdirectory(python)
endif()

if (USE_PVS_STUDIO)
  set(PVS_STUDIO_TARGET_NAME "iresearch-pvs-check")
  set(PVS_STUDIO_ANALYZE ${IResearch_TARGET_NAME}-static
                         ${IResearchUtil_TARGET_NAME}
                         ${IResearchBenchmarks_TARGET_NAME}
                         ${IResearchPython_TARGET_NAME})

  pvs_studio_add_target(
    TARGET ${PVS_STUDIO_TARGET_NAME} ALL
    OUTPUT FORMAT errorfile
    ANALYZE ${PVS_STUDIO_ANALYZE}
    MODE GA:1,2 OP
    LOG ${IResearch_TARGET_NAME}.err
    CONFIG "${CMAKE_SOURCE_DIR}/PVSIResearch.cfg"
  )

  set_target_properties(
    ${PVS_STUDIO_TARGET_NAME}
    PROPERTIES
    COMPILE_DEFINITIONS "$<$<CONFIG:Coverage>:IRESEARCH_DEBUG>;$<$<CONFIG:Debug>:IRESEARCH_DEBUG>"
  )

  pvs_studio_add_target(
    TARGET ${PVS_STUDIO_TARGET_NAME}-html ALL
    FORMAT fullhtml
    ANALYZE ${PVS_STUDIO_ANALYZE}
    MODE GA:1,2 OP
    LOG ${IResearch_TARGET_NAME}-html.err
    CONFIG "${CMAKE_SOURCE_DIR}/PVSIResearch.cfg"
  )

  set_target_properties(
    ${PVS_STUDIO_TARGET_NAME}-html
    PROPERTIES
    COMPILE_DEFINITIONS "$<$<CONFIG:Coverage>:IRESEARCH_DEBUG>;$<$<CONFIG:Debug>:IRESEARCH_DEBUG>"
  )

  pvs_studio_add_target(
    TARGET ${PVS_STUDIO_TARGET_NAME}-xml ALL
    FORMAT xml
    ANALYZE ${PVS_STUDIO_ANALYZE}
    MODE GA:1,2 OP
    LOG ${IResearch_TARGET_NAME}-xml.err
    CONFIG "${CMAKE_SOURCE_DIR}/PVSIResearch.cfg"
  )

  set_target_properties(
    ${PVS_STUDIO_TARGET_NAME}-xml
    PROPERTIES
    COMPILE_DEFINITIONS "$<$<CONFIG:Coverage>:IRESEARCH_DEBUG>;$<$<CONFIG:Debug>:IRESEARCH_DEBUG>"
  )
endif()

if (USE_MICRO_BENCHMARCH)
  add_subdirectory(microbench)
endif()

if (USE_TESTS)
  add_subdirectory(tests)

  # setup code coverage
  if (NOT MSVC AND (CMAKE_BUILD_TYPE STREQUAL "Coverage"))
    include(CodeCoverage)

    # exclude directories from coverage report
    SET(LCOV_EXCLUDE "external/*;boost/*;${LCOV_EXCLUDE}")

    setup_target_for_coverage(
      ${IResearch_TARGET_NAME}-coverage 
      $<TARGET_FILE:${IResearchTests_TARGET_NAME}-static>
      coverage
      "--ires_output"
    )
    add_dependencies(${IResearch_TARGET_NAME}-coverage
      ${IResearchTests_TARGET_NAME}-static
    )

    if (PYTHON_EXECUTABLE AND GCOVR_PATH)   
      # exclude directories from coverage report
      SET(GCOVR_EXTRA_ARGS "-e;${PROJECT_SOURCE_DIR}/external/;${GCOVR_EXTRA_ARGS}")

      setup_target_for_coverage_cobertura(
        ${IResearch_TARGET_NAME}-coverage-cobertura
        $<TARGET_FILE:${IResearchTests_TARGET_NAME}-static>
        coverage
        "--ires_output"
      )
      setup_target_for_collecting_coverage_cobertura(
        ${IResearch_TARGET_NAME}-coverage-cobertura-collect
        coverage
      )
      add_dependencies(${IResearch_TARGET_NAME}-coverage-cobertura-collect
        ${IResearchTests_TARGET_NAME}-static
      )
    endif()
  endif()

  # testing
  enable_testing()
  add_test(
    iresearch-tests
    ${EXECUTABLE_OUTPUT_PATH}/iresearch-tests${CMAKE_EXECUTABLE_SUFFIX}
  )

  # testing auto build not working
  # due to the following bug in cmake
  # http://public.kitware.com/Bug/view.php?id=8774
  # here is the workaround:
  add_custom_target(iresearch-check
    COMMAND ${CMAKE_CTEST_COMMAND} 
    DEPENDS iresearch-tests
  )

  # setup target for memory allocation profiling
  add_custom_target(iresearch-tests-malloc
    COMMAND ${CMAKE_COMMAND} -E echo "Arguments to valgrind may be provided via an environment variable 'EXTRA_VALGRIND_ARGS'"
    COMMAND ${CMAKE_COMMAND} -E echo "Arguments to iresearch-tests${CMAKE_EXECUTABLE_SUFFIX} may be provided via an environment variable 'EXTRA_VALGRIND_PROG_ARGS'"
    COMMAND valgrind --tool=massif --depth=100 --max-snapshots=500 --time-unit=ms --detailed-freq=1 --massif-out-file=massif.out $$EXTRA_VALGRIND_ARGS ${EXECUTABLE_OUTPUT_PATH}/iresearch-tests${CMAKE_EXECUTABLE_SUFFIX} --ires_output $$EXTRA_VALGRIND_PROG_ARGS
    COMMAND ms_print --x=500 --y=100 massif.out > massif.log
    DEPENDS iresearch-tests
  )

  # setup target for memory allocation profiling
  add_custom_target(iresearch-tests-malloc-s
    COMMAND ${CMAKE_COMMAND} -E echo "Arguments to valgrind may be provided via an environment variable 'EXTRA_VALGRIND_ARGS'"
    COMMAND ${CMAKE_COMMAND} -E echo "Arguments to iresearch-tests${CMAKE_EXECUTABLE_SUFFIX} may be provided via an environment variable 'EXTRA_VALGRIND_PROG_ARGS'"

=== 3rdParty/jemalloc/CMakeLists.txt ===
# -*- mode: CMAKE; -*-

project(jemalloc C)
include(ExternalProject)

# set version and paths
set(JEMALLOC_VERSION "5.2.1")
set(JEMALLOC_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/v${JEMALLOC_VERSION}")
set(JEMALLOC_BINARY_DIR "${CMAKE_CURRENT_BINARY_DIR}/v${JEMALLOC_VERSION}")

# export to paths to parent scope
set(JEMALLOC_VERSION "${JEMALLOC_VERSION}" PARENT_SCOPE)

# copy files into binary directory
file(
  COPY
    "${JEMALLOC_SOURCE_DIR}"
  DESTINATION
    "${CMAKE_CURRENT_BINARY_DIR}"
)

# generate external project
if (LINUX OR DARWIN)
  if (DARWIN)
    set(JEMALLOC_CC_TMP "cc")
    set(JEMALLOC_CXX_TMP "c++}")
    set(JEMALLOC_CONFIG "background_thread:false")
  else ()
    set(JEMALLOC_CC_TMP "${CMAKE_C_COMPILER}")
    set(JEMALLOC_CXX_TMP "${CMAKE_CXX_COMPILER}")
    set(JEMALLOC_CONFIG "background_thread:true")
  endif ()

  if (USE_JEMALLOC_PROF)
    SET(JEMALLOC_PROF "--enable-prof")
  endif ()

  set(JEMALLOC_LIB "${CMAKE_CURRENT_BINARY_DIR}/lib/libjemalloc.a")
  ExternalProject_Add(
    jemalloc_build
    SOURCE_DIR
      ${JEMALLOC_BINARY_DIR}
    PREFIX
      ${JEMALLOC_BINARY_DIR}
    PATCH_COMMAND
      cmake -E touch
        ${JEMALLOC_BINARY_DIR}/doc/jemalloc.html
        ${JEMALLOC_BINARY_DIR}/doc/jemalloc.3
    CONFIGURE_COMMAND
      "${JEMALLOC_SOURCE_DIR}/configure" CC=${JEMALLOC_CC_TMP}
                  CXX=${JEMALLOC_CXX_TMP}
                  CFLAGS=${CMAKE_C_FLAGS}
                  CXXFLAGS=${CMAKE_CXX_FLAGS}
                  --prefix=${CMAKE_CURRENT_BINARY_DIR}
                  --with-malloc-conf=${JEMALLOC_CONFIG}
                  --with-version=${JEMALLOC_VERSION}-0-g0
		  ${JEMALLOC_PROF}
    BUILD_COMMAND
      $(MAKE) build_lib_static
    BUILD_IN_SOURCE
      1
    INSTALL_COMMAND
      $(MAKE) install_include
           && ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/lib
           && ${CMAKE_COMMAND} -E copy ${JEMALLOC_BINARY_DIR}/lib/libjemalloc.a ${CMAKE_CURRENT_BINARY_DIR}/lib
    STEP_TARGETS
      ${JEMALLOC_LIB} jemalloc
  )

  set(JEMALLOC_HOME "${CMAKE_CURRENT_BINARY_DIR}" PARENT_SCOPE)
  set(JEMALLOC_LIB "${JEMALLOC_LIB}" PARENT_SCOPE)
endif ()

=== Installation/debian/control ===
Source: arangodb3
Section: database
Priority: optional
Maintainer: ArangoDB GmbH <info@arangodb.com>
Build-Depends: debhelper (>= 5), libreadline-dev, libssl-dev, python, libicu-dev, libtool, autoconf, automake

Package: arangodb3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: arangodb3-client
Description: a multi-purpose NoSQL database
 A distributed free and open-source database with a flexible data model for documents,
 graphs, and key-values. Build high performance applications using a convenient
 SQL-like query language or JavaScript extensions.
 .
 Copyright: 2012-2013 by triAGENS GmbH
 Copyright: 2014-2015 by ArangoDB GmbH
 ArangoDB Software
 www.arangodb.com

Package: arangodb3-client
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: arangodb
Description: stand-alone shell
 A distributed free and open-source database with a flexible data model for documents,
 graphs, and key-values. Build high performance applications using a convenient
 SQL-like query language or JavaScript extensions.
 .
 Copyright: 2012-2013 by triAGENS GmbH
 Copyright: 2014-2015 by ArangoDB GmbH
 ArangoDB Software
 www.arangodb.com

Package: arangodb-dbg
Architecture: any
Section: debug
Priority: extra
Depends:
    arangodb (= ${binary:Version}),
    ${misc:Depends}
Description: debugging symbols for arangodb
 A distributed free and open-source database with a flexible data model for documents,
 graphs, and key-values. Build high performance applications using a convenient
 SQL-like query language or JavaScript extensions.
 .
 This package contains the debugging symbols for giblib1.
